﻿//================================================================================
//  
//       MainForm.cs      メインフォーム画面
//  
//        (c)2012/08/28  by OjisanKoubou
//  
//================================================================================
//  
//  このプログラムは Ojisankoubou( OGAWA Ichiro ) が著作権を持っています。
//  個人の研究目的には、修正、改造など自由に使用できます。
//  発表される際は著作権表示部分を消さないようにしてください。
//  このソフトウェアの全部もしくは一部を製品に組み込んだり販売したりするなどの
//  商業的利用はできません。
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace APB_3
{
    public partial class MainForm : Form
    {
        private static StringBuilder sb_log = new StringBuilder();
        private static LogForm logform = null;
        private delegate void DelegateType();
        
        public static float dpi = 96;       // 画面 ｄｐｉ設定値
        
        
        
        public MainForm()
        {
            InitializeComponent();
            
            Apb3.mainf = this;
            
            Graphics g = this.CreateGraphics();   //画面 dpi を取得
            dpi = g.DpiX;
            g.Dispose();
            LogPrint( dpi.ToString() + " dpi\n" );
            
//            logform = new LogForm();
//            logform.Print(sb_log.ToString());
//            logform.Show();
            
        }
        
        
        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            Apb3.Ft232h.FtClose();
        }
        
        
        
        //
        // スペアナ画面
        //
        private void ToolStripMenuItem_speana_Click(object sender, EventArgs e)
        {
            SpeanaView f = new SpeanaView(false);
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // ネットアナ画面
        //
        private void ToolStripMenuItem_netana_Click(object sender, EventArgs e)
        {
            SpeanaView f = new SpeanaView(true);
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // インピーダンスアナライザ画面
        //
        private void ToolStripMenuItem_impana_Click(object sender, EventArgs e)
        {
            ImpedanceView f = new ImpedanceView();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // ＦＭアナライザ画面
        //
        private void ToolStripMenuItem_fmana_Click(object sender, EventArgs e)
        {
            FMView f = new FMView();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // 周波数アナライザ画面
        //
        private void ToolStripMenuItem_freqana_Click(object sender, EventArgs e)
        {
            FreqCounterForm f = new FreqCounterForm();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
           
        }
        
        
        //
        // 信号発生器画面
        //
        private void ToolStripMenuItem_sg_Click(object sender, EventArgs e)
        {
            HfSGForm f = new HfSGForm();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // オーディオ信号発生器画面
        //
        private void ToolStripMenuItem_audiosg_Click(object sender, EventArgs e)
        {
            AudioSGForm f = new AudioSGForm();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // 復調器画面
        //
        private void ToolStripMenuItem_demod_Click(object sender, EventArgs e)
        {
            DemodForm f = new DemodForm();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // オシロ画面
        //
        private void ToolStripMenuItem_oscillo_Click(object sender, EventArgs e)
        {
            OscilloView f = new OscilloView();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // 測定データ保存
        //
        private void ToolStripMenuItem_save_Click(object sender, EventArgs e)
        {
            
        }
        
        
        //
        // 接続
        //
        private void ToolStripMenuItem_connect_Click(object sender, EventArgs e)
        {
            
        }
        
        
        //
        // 終了
        //
        private void ToolStripMenuItem_exit_Click(object sender, EventArgs e)
        {
            
        }
        
        
        //
        // 設定保存
        //
        private void ToolStripMenuItem_savesetting_Click(object sender, EventArgs e)
        {
            
        }
        
        
        //
        // 設定読み込み
        //
        private void ToolStripMenuItem_readsetting_Click(object sender, EventArgs e)
        {
            
        }
        
        
        //
        // 初期設定に戻す
        //
        private void ToolStripMenuItem_initialsetting_Click(object sender, EventArgs e)
        {
            
        }
        
        
        //
        // ログ画面
        //
        private void toolStripMenuItem_log_Click(object sender, EventArgs e)
        {
            //LogPrint("\nMainForm.ToolStripMenuItem_log_Click");
            if ((logform == null) || (logform.IsDisposed))
            {
                logform = new LogForm();
                logform.Print(sb_log.ToString());
            }
            logform.Show();
        }
        
        
        //
        // ログをクリップボードにコピー
        //
        private void ToolStripMenuItem_logcopy_Click(object sender, EventArgs e) {
            Clipboard.SetDataObject(sb_log.ToString());
        }
        
        
        //
        // FlashROM にコンフィグデータ書き込み
        //
        private void ToolStripMenuItem_flashwrite_Click(object sender, EventArgs e)
        {
            if( MessageBox.Show("Flash ROM にコンフィグデータを書き込みますか？\r\rコンフィグファイルを選択したあと、書き込み終了までしばらくお待ちください。\r書き込みには約 20 秒かかります。", "Flash 書き込み", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) == DialogResult.Yes )
            {
                if( Apb3.Df.DfWriteConfig() )
                {
                    MessageBox.Show("Flash ROM にコンフィグデータを正常に書き込みました。", "Flash 書き込み", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }else{
                    error.ErrorMessageBox(error.df_write);
                }
            }
        }
        
        
        //
        // ＦＴ２３２Ｈデバイス情報
        //
        private void ToolStripMenuItem_ft232_Click(object sender, EventArgs e)
        {
            
        }
        
        
        //
        // ＦＰＧＡコンフィグ
        //
        private void ToolStripMenuItem_config_Click(object sender, EventArgs e)
        {
            string str;
//            if( Apb3.FpgaConfig() ) {
            Apb3.CloseConnection();
            if( Apb3.Open() ) {
                str = "ＦＰＧＡをコンフィグしました。\r\rFPGA version : " + Apb3.FpgaSignature();
                Apb3.Close();
            }else{
                str = "ＦＰＧＡのコンフィグができませんでした。\r\rＵＳＢ接続や電源を確認の上、再度実行してください。";
            }
            MessageBox.Show(str, "ＦＰＧＡコンフィグ");
        }
        
        
        //
        // APB-3 基板との接続を切断
        //
        private void ToolStripMenuItem_closeapb3_Click(object sender, EventArgs e)
        {
            Apb3.CloseConnection();
        }
        
        
        //
        // 診断画面
        //
        private void toolStripMenuItem_diag_Click(object sender, EventArgs e)
        {
            DiagnosticsForm f = new DiagnosticsForm();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // デバッグ画面
        //
        private void ToolStripMenuItem_debug_Click(object sender, EventArgs e)
        {
            DebugForm f = new DebugForm();
            if (this.ActiveMdiChild != null)
            {
                f.WindowState = this.ActiveMdiChild.WindowState;
            }
            else
            {
                f.WindowState = FormWindowState.Maximized;
            }
            f.MdiParent = this;
            f.Show();
        }
        
        
        //
        // ウィンドウ整列　重ねて
        //
        private void ToolStripMenuItem_cascade_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.Cascade);
        }
        
        
        //
        // ウィンドウ整列　左右
        //
        private void ToolStripMenuItem_tilehorizontal_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileHorizontal);
        }
        
        
        //
        // ウィンドウ整列　上下
        //
        private void ToolStripMenuItem_tilevertical_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileVertical);
        }
        
        
        //
        // バージョン表示
        //
        private void ToolStripMenuItem_version_Click(object sender, EventArgs e)
        {
            string apb3version = "　・PC   : " + def.version + "\n\n";
            string fpgaversion = "　・FPGA : ";
            if (Apb3.Open())
            {
                fpgaversion += Apb3.FpgaSignature() + "\n\n";
                Apb3.Close();
            }
            LogPrint("\n" + apb3version + fpgaversion);
            MessageBox.Show(def.credit + "    \n\n" + apb3version + fpgaversion, "バージョン");
        }
        
        
        //
        // おじさん工房のｗｅｂサイトを開く
        //
        private void ToolStripMenuItem_ojisankoubou_Click(object sender, EventArgs e)
        {
            Process.Start("http://ojisankoubou.web.fc2.com/");
        }
        
        
        //
        // トラ技のｗｅｂサイトを開く
        //
        private void ToolStripMenuItem_toragi_Click(object sender, EventArgs e)
        {
            Process.Start("http://toragi.cqpub.co.jp/");
        }
        
        
        //
        // ログプリント（別スレッドから呼び出してもOK）
        //
        public void LogPrint( string str )
        {
            try
            {
                sb_log.Append(str);
                if ((logform != null) && (!logform.IsDisposed))
                {
                    BeginInvoke((DelegateType)delegate
                    {
                        logform.Print(str);
                    });
                }
            }
            catch
            {
            }
        }
        //
        // ログプリント ストップウオッチ付き（別スレッドから呼び出してもOK）
        //
        public void LogPrint( string str, Stopwatch sw )
        {
            str += " "+((double)sw.ElapsedTicks / (double)Stopwatch.Frequency * 1000).ToString("#0.0") + "msec";
            LogPrint( str );
        }
        
    }
}
