﻿//================================================================================
//  
//        Utility.cs        共通に使うルーチンや定義を集めたクラス
//  
//        (c)2009/07/26  by OjisanKoubou
//  
//================================================================================
//  
//  このプログラムは Ojisankoubou( OGAWA Ichiro ) が著作権を持っています。
//  個人の研究目的には、修正、改造など自由に使用できます。
//  発表される際は著作権表示部分を消さないようにしてください。
//  このソフトウェアの全部もしくは一部を製品に組み込んだり販売したりするなど商業的利用はおやめください。
//

using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Drawing;
using System.Windows.Forms;


namespace APB_3 {

    // ------------------------------------------------------------------------------------
    //     設定を集めたクラス
    // ------------------------------------------------------------------------------------
    public class def
    {
        public static string credit  = "APB-3 制御ソフトウェア  (c)2012 OjisanKoubou";
        public static string version = "20120917";
        
        public static string pre        = "PRE";
        public static string wait       = "WAIT";
        public static string trgd       = "TRGD";
        public static string measure    = "測定";
        public static string sweep      = "掃引中";
        public static string stop       = "中止";
        public static string end        = "終了";
        public static string setting    = "設定";
        public static string receive    = "受信開始";
        public static string agc        = "AGC 開始";
        public static string zerofreq   = "ゼロ周波数に設定";
        public static string zerofreq_x = "ゼロ周波数解除";
        
        
        // スペアナ
        public static string[] freqstartstrtbl = new string[] {
            "  20 M", "  10 M", "   5 M", "   2 M",
            "   1 M", " 500 k", " 200 k", " 100 k", "  50 k",
            "  20 k", "  10 k", "     0" };
        
        public static string[] freqstopstrtbl = new string[] {
            "  30 M", "  20 M", "  10 M", "   5 M", "   2 M",
            "   1 M", " 500 k", " 200 k", " 100 k", "  50 k",
            "  20 k", "  10 k"};
        
        public static string[] freqspanstrtbl = new string[] {
            "  40 M", "  20 M", "  10 M", "   5 M", "   2 M",
            "   1 M", " 500 k", " 200 k", " 100 k", "  50 k",
            "  20 k", "  10 k", "   5 k", "   2 k", "   1 k",
            "   500", "   200", "   100" };
        
        public static string[] rbwstrtbl = new string[] {
            " 60 kHz", " 30 kHz", " 15 kHz", "  7 kHz", "  4 kHz", "  2 kHz", "  1 kHz", " 500 Hz", " 200 Hz",
            " 100 Hz", "  60 Hz", "  30 Hz", "  15 Hz", "   7 Hz"};
        
        public static string[] rbwstrtbl_netana = new string[] {
            " 30 kHz", " 15 kHz", "  7 kHz", "  4 kHz", "  2 kHz", "  1 kHz", " 500 Hz", " 200 Hz",
            " 100 Hz", "  60 Hz", "  30 Hz", "  15 Hz", "   7 Hz"};
        
        
        public static string[] nstrtbl = new string[] {
            "10", "20", "50", "100", "200", "500", "1000" };
        
        public static double[] decimationtbl = new double[] {
             1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 4096 };
        
        
        // スペアナ設定
        public static string[] mesmodestrtbl = new string[] {
            "  シングル", "  連続", "   2回", "   5回", "  10回", "  20回", "  50回", " 100回"};
        
        public static string[] minpointstrtbl = new string[] {
            " 自動", "  20", "  50", " 100", " 200", " 500", "1000"};
        
        public static string[] fftbinstrtbl = new string[] {
            "  16", "  32", "  64", " 128", " 256", " 512"};
        
        public static string[] averagingstrtbl = new string[] {
            " なし", "   2", "   5", "  10", "  20", "  50", " 100", " 200", " 500", "1000" };
        
        
        // スペアナ　コンテキストメニュー
        public static string[] axisstrtbl = new string[] {
            "振幅", "位相", "群遅延" };
        
        public static string[] dbrefstrtbl = new string[] {
            "+40 dB", "+30 dB", "+20 dB", "+10 dB", "0 dB", "-10 dB", "-20 dB", "-30 dB", "-40 dB" };
        
        public static string[] dbdivstrtbl = new string[] {
            "10 dB/div", "5 dB/div", "2 dB/div", "1 dB/div", "0.5 dB/div" };
        
        public static string[] degrefstrtbl = new string[] {
            "225 deg", "180 deg", "135 deg", "90 deg", "45 deg", "0 deg", "-45 deg", "-90 deg", "-135 deg" };
        
        public static string[] degdivstrtbl = new string[] {
            "45 deg/div", "30 deg/div", "20 deg/div", "15 deg/div", "10 deg/div", "5 deg/div", "2 deg/div", "1 deg/div" };
        
        public static string[] secrefstrtbl = new string[] {
            "100 usec", "50 usec", "20 usec", "10 usec", "5 usec",
            "2 usec", "1 usec", "500 nsec", "200 nsec", "100 nsec", "50 nsec", "20 nsec", "10 nsec"  };
        
        public static string[] secdivstrtbl = new string[] {
            "10 usec/div", "5 usec/div", "2 usec/div", "1 usec/div", "500 nsec/div",
            "200 nsec/div", "100 nsec/div", "50 nsec/div", "20 nsec/div", "10 nsec/div",
            "5 nsec/div", "2 nsec/div", "1 nsec/div"  };
        
        
        // ロジアナ画面
        public static double[] samplingtimetbl = new double[17] {
            5e-9, 10e-9, 25e-9, 50e-9,  100e-9,
            200e-9,  500e-9,  1e-6,  2e-6,   5e-6,
            10e-6,   20e-6,   50e-6, 100e-6, 200e-6,
            500e-6,  1e-3 };
        
        public static string[] samplingtimestrtbl = new string[] {
            "    5 ns", "   10 ns", "   25 ns", "   50 ns", "  100 ns", 
            "  200 ns", "  500 ns", "    1 us", "    2 us", "    5 us", 
            "   10 us", "   20 us", "   50 us", "  100 us", "  200 us",
            "  500 us", "    1 ms"};
        
        public static string[] samplingwidthstrtbl = new string[] {
            " 16 bit", " 8 bit"};
        
        public static string[] samplingmodestrtbl = new string[] {
            " フリーラン", " トリガー"};
        
        public static string[] triggerposstrtbl = new string[] {
            " 先頭", "  1/8", " 中央", "  7/8"};
        
        public static string[] triggermodestrtbl = new string[] {
            "L(不一致)", "H(一致)", "立ち下がり", "立ち上がり"};
        
        public static string[] triggersourcestrtbl = new string[] {
            " D 0 ", " D 1 ", " D 2 ", " D 3 ", " D 4 ", 
            " D 5 ", " D 6 ", " D 7 ", " D 8 ", " D 9 ", 
            " D 10", " D 11", " D 12", " D 13", " D 14", 
            " D 15", " パターン1", " パターン2", " パターン3", " パターン4" };
        
        
        
        // ロジアナ
        public static int[] clkseltbl = new int[17] {  // FPGA に送るクロック選択番号 3:80M 4:40M ...
            3, 3, 4, 5, 7, 8, 10, 11, 12, 14, 15, 16, 18, 19, 20, 22, 23 };
        
        
        
        // TimeGraphWaveProperty
        public static string[] datastrtbl = new string[] {      // 
            "D 0" , "D 1" , "D 2" , "D 3" , "D 4" , "D 5" , "D 6" , "D 7" , 
            "D 8" , "D 9" , "D 10", "D 11", "D 12", "D 13", "D 14", "D 15" };
        
        public static string[] widthstrtbl = new string[] {     // ビット幅
            "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16" };
        
        public static string[] radixstrtbl = new string[] {
            "2進", "8進", "10進", "10進(符号付)", "16進", "アナログ", "アナログ(符号付)" };
        
        public static string[] heightstrtbl = new string[] {    // 波形表示高さ
            "12", "15", "18", "20", "50", "100", "150", "200", "300" };
        
        
        
        // FM復調器
        public static double[] FMsamplingtimetbl = new double[] {   // サンプリングタイム
            320e-9, 640e-9, 1280e-9, 2560e-9, 
            5120e-9, 10240e-9, 20480e-9, 40960e-9,
            81920e-9, 163840e-9, 327680e-9, 655360e-9,
            1310720e-9, 2621440e-9, 5242880e-9, 10485760e-9,
            20971520e-9, 41943040e-9, 83886080e-9, 167772160e-9,
            335544320e-9, 671088640e-9, 1342177280e-9, 2684352560e-9};

        public static double[] FMperbittbl = new double[] {         // 復調感度
            47.684, 23.842, 11.921, 5.9605, 
            2.9802, 1.4901, 0.74506, 0.37253,
            0.18626, 9.3132e-2, 4.6566e-2, 2.3283e-2,
            1.1641e-2, 5.8208e-3, 2.9104e-3, 1.4552e-3,
            7.2760e-4, 3.6380e-4, 1.8190e-4, 9.0949e-5,
            4.5475e-5, 2.2737e-5, 1.1369e-5, 5.6843e-6 };

        public static string[] FMsamplingmodestrtbl = new string[] {
            "フリーラン", "立ち上がり", "立ち下がり"};
        
        public static int[] FMaveragingtbl = new int[] {         // 平均化
            1, 2, 4, 8, 16, 32, 64, 128, 256 };


        public static string[] FMfreqstrtbl = new string[] {  // 変換周波数
            " 10 M",
            "  9 M", "  8 M", "  7 M", "  6 M", "  5 M", "  4 M", "  3 M", "  2 M", "  1 M",
            " 900 k", " 800 k", " 700 k", " 600 k", " 500 k", " 400 k", " 300 k", " 200 k", " 100 k",
            " 90 k", " 80 k", " 70 k", " 60 k", " 50 k", " 40 k", " 30 k", " 20 k", " 10 k"};

        public static string[] FMfreqdeltastrtbl = new string[] {  // 周波数増減
            "  1 M", " 500 k", " 200 k", " 100 k", " 50 k", " 20 k", " 10 k",
            "  1 k", "   500", "   200", "   100", "   50", "   20", "   10"};

        public static string[] FMinputstrtbl = new string[] {  // 入力信号
            "  D 0", "  D 1", "  D 2", "  D 3", "  D 4", "  D 5", "  D 6", "  D 7", 
            "  AD "};

        public static string[] FMbwstrtbl = new string[] {  // 帯域幅
            "±1563 k", "±780 k", "±390 k", "±195 k", "±98 k", "±49 k", "±24 k"};

        public static string[] FMaqstrtbl = new string[] {  // Aquisition
            " 1/1", " 1/2", " 1/4", " 1/8", " 1/16", " 1/32", " 1/64", " 1/128",
            " 1/256", " 1/512", " 1/1024", " 1/2048", " 1/4096", " 1/8192", 
            " 1/16384", " 1/32768", " 1/65536"};

        public static double[] FMperdivtbl = new double[] {     // 垂直軸  Hz/div
            500e3, 200e3, 100e3, 50e3, 20e3, 10e3, 5e3, 2e3, 1e3,
            500, 200, 100, 50, 20, 10, 5, 2, 1};
        

        // 周波数カウンター
        public static string[] FCinputstrtbl = new string[] {  // 入力信号
            "  D 0", "  D 1", "  D 2", "  D 3", "  D 4", "  D 5", "  D 6", "  D 7", 
            "  AD "};

        public static string[] FCintervalstrtbl = new string[] {  // 測定間隔
            " 0.5 s", "  1 s", "  2 s", "  5 s", "  10 s" };

        public static double[] FCintervaltbl = new double[] {  // 測定間隔
            0.5, 1, 2, 5, 10, 20, 30, 60, 100, 300 };

        // オシロ
        public static double[] ossamplingtimetbl = new double[] {
            10e-9, 20e-9, 40e-9,  80e-9,  160e-9,
            320e-9,  640e-9,  1.28e-6,   2.56e-6, 5.12e-6,
            10.24e-6,   20.48e-6, 40.96e-6 };
        
        public static string[] ossamplingtimestrtbl = new string[] {    // オシロのサンプリングタイム
            "   10 ns", "   20 ns", "   40 ns", "   80 ns", "  160 ns",
            "  320 ns", "  640 ns", "   1.3 us", "   2.6 us", "   5.1 us",
            "   10 us", "   20 us", "   41 us"};
        
//        public static string[] ossamplingmodestrtbl = new string[] {  // モード
//            "AD波形", "ABS+PHA", "I+Q"};
        
//        public static string[] osfreqstrtbl = new string[] {  // 変換周波数
//            "変換しない", " 30 M", " 20 M", " 10 M",
//            "  9 M", "  8 M", "  7 M", "  6 M", "  5 M", "  4 M", "  3 M", "  2 M", "  1 M",
//            " 900 k", " 800 k", " 700 k", " 600 k", " 500 k", " 400 k", " 300 k", " 200 k", " 100 k"};
        
        public static double[] osperdivtbl = new double[] {     // 垂直軸  /div
            5000, 2000, 1000, 500, 200, 100, 50, 20, 10, 5, 2, 1, 1};
        
        public static string[] ossamplingmodestrtbl = new string[] {
            "フリーラン", "立ち上がり", "立ち下がり"};
        
        public static string[] osthresholdstrtbl = new string[] {     // スレショルド
            "32", "64", "128", "256", "512", "1024", "2048", "4096"};
        
        
        // 信号発生器
        public static string[] hfsgfreqstrtbl = new string[] {  // 周波数
            " 30 M", " 20 M", " 10 M",
            "  9 M", "  8 M", "  7 M", "  6 M", "  5 M", "  4 M", "  3 M", "  2 M", "  1 M",
            " 900 k", " 800 k", " 700 k", " 600 k", " 500 k", " 400 k", " 300 k", " 200 k", " 100 k", 
            "  90 k", "  80 k", "  70 k", "  60 k", "  50 k", "  40 k", "  30 k", "  20 k", "  10 k", 
            "   9 k", "   8 k", "   7 k", "   6 k", "   5 k", "   4 k", "   3 k", "   2 k", "   1 k", 
            "  900 ", "  800 ", "  700 ", "  600 ", "  500 ", "  400 ", "  300 ", "  200 ", "  100 ", 
            "   90 ", "   80 ", "   70 ", "   60 ", "   50 ", "   40 ", "   30 ", "   20 ", "   10 "};

        public static string[] hfsgfreqstepstrtbl = new string[] {  // 周波数ステップ
            "  10 M","   5 M","   2 M","   1 M", " 500 k", " 200 k", " 100 k", "  50 k",  "  20 k",
            "  10 k", "   5 k","   2 k","   1 k", "   500", "   200", "   100", "    50",     "    20",
            "    10",  "     5",     "     2", "     1"};
        
        
        public static string[] hfsglevelstrtbl = new string[] {  // レベル
            " 0", " -10", " -20", " -30", " -40", " -50", " -60"};
        
        public static int[] hfsgleveltbl = new int[] {        // インデックスからレベルへ変換
             65535, 20724, 6554, 2072, 655, 207, 66, 21, 7};
        
        public static string[] hfsglevelstepstrtbl = new string[] {  // レベルステップ
            " 10", " 5", " 2", " 1", " 0.5", " 0.2", " 0.1"};
        
        public static string[] hfsgmodlevelamstrtbl = new string[] {  // AM変調度
            " 100 %", "  50 %", "  25 %", "  12.5 %", "   6.25 %",
            "   3.13 %", "   1.56 %", "   0.78 %"}; //, "   0.39 %", "   0.20 %",
        
        public static string[] hfsgmodlevelfmstrtbl = new string[] {  // FM変調度
            " ±25 MHz", " ±12.5 MHz"," ±6.25 MHz", " ±3.12 MHz", " ±1.56 MHz",
            " ±781 kHz", " ±391 kHz"," ±195 kHz", " ±98 kHz", " ±49 kHz",
            " ±24 kHz", " ±12 kHz"," ±6104 Hz", " ±3052 Hz", " ±1526 Hz"};
        
        
        
        // オーディオ信号発生器
        public static string[] audiosgwavestrtbl = new string[] {  // 波形
            " サイン", " 矩形波", "のこぎり波", " 三角波" };
        
        public static string[] audiosgfreqstrtbl = new string[] {  // 周波数
            " 40 k", " 30 k", " 20 k", " 10 k",
            "  9 k", "  8 k", "  7 k", "  6 k", "  5 k", "  4 k", "  3 k", "  2 k", "  1 k", 
            " 900 ", " 800 ", " 700 ", " 600 ", " 500 ", " 400 ", " 300 ", " 200 ", " 100 ", 
            "  90 ", "  80 ", "  70 ", "  60 ", "  50 ", "  40 ", "  30 ", "  20 ", "  10 ", };
        
        public static string[] audiosgfreqstepstrtbl = new string[] {  // 周波数増減
            " 10 k","  5 k", "  2 k", "  1 k",
            " 500 ", " 200 ", " 100 ",
            "  50 ", "  20 ", "  10 ",
            "   5 ", "   2 ", "   1 " };
        
        public static string[] audiosglevelstrtbl = new string[] {  // レベル
            "   0", "  -6", " -12", " -18", " -24",
            " -30", " -36", " -42", " -48", " -54",
            " -60", " -66", " -72", " -78", " -84",
            " -90"};
        
        public static string[] audiosgphasestrtbl = new string[] {  // 位相
            " 180", " 135", "  90", "  60", "  45", "  30", "  20", "  15", "  10", "   5", "   0",
            "  -5", " -10", " -15", " -20", " -30", " -45", " -60", " -90", " -135"};
        
        
        
        // 復調器
        public static string[] demodfreqstrtbl = new string[] {  // 周波数
            " 30 M", " 20 M", " 10 M", "  9 M", "  8 M",
            "  7 M", "  6 M", "  5 M", "  4 M", "  3 M",
            "  2 M", "  1 M", "1422 k", "1242 k", "1134 k",
            " 954 k", " 810 k"," 693 k", " 594k" };
        
        public static string[] demodfreqstepstrtbl = new string[] {  // 周波数ステップ
            "   1 M", " 500 k", " 200 k", " 100 k", "  50 k",
            "  20 k", "  10 k", "   9 k", "   5 k", "   2 k",
            "   1 k", "   500", "   200", "   100", "    50",
            "    20", "    10", };

        public static string[] demodgainstrtbl = new string[] {  // ゲイン
            "   AGC  ", "    0 dB", "    6 dB", "   12 dB", "   18 dB",
            "   24 dB", "   30 dB", "   36 dB", "   42 dB",
            "   48 dB", "   54 dB", "   60 dB", "   66 dB",
            "   72 dB", "   78 dB", "   84 dB", "   90 dB"};

        public static string[] demodbwstrtbl = new string[] {       // 帯域幅
            " 160 k", "  80 k",  "  40 k", "  20 k", "  10 k"};
        
        public static string[] demodmodstrtbl = new string[] {  // 復調方式
            "   LSB", "   USB", "   AM", "   I + Q"};
        
        public static int[] prebandtbl = new int[] {  // Preamp band番号とHC595へ送るデータのテーブル 
            0x38, 0x31, 0x2A, 0x23, 0x1C, 0x15, 0x0E, 0x07};
        
        public static string[] prefreqstrtbl = new string[17] {  // 周波数
            "THRU", " 30 M", " 25 M", " 20 M", " 16 M", " 15 M",
            " 12.5 M", " 10 M", "  8 M", "  8 M", "  5 M",
            "  3 M", "  2 M", "2000 k", "1200 k", " 800 k",
            " 500 k" };
        
        
        // デバッグ　ツール
        public static string[] dac900freqstrtbl = new string[] {  // ＤＡＣ９００　出力周波数
            "  10 M","   1 M", " 100 k", "  10 k", "   1 k", "   100"};
        
        public static string[] pcm1754freqstrtbl = new string[] {  // ＰＣＭ１７５４　出力周波数
            "  10 k", "   4 k", "   1 k", "   400", "   100"};
        
        
        
        
        
        // 
        public static double[] freqtbl = new double[] {
            0, 10, 20, 50, 100, 200, 500, 1e3, 2e3, 5e3, 10e3, 20e3, 50e3,
            100e3, 200e3, 500e3, 1e6, 2e6, 5e6, 10e6, 20e6, 40e6 };
        
        public static string[] freqstrtbl = new string[] {
            "0 Hz", "10 Hz", "20 Hz", "50 Hz", "100 Hz", "200 Hz", "500 Hz",
            "1 kHz", "2 kHz", "5 kHz", "10 kHz", "20 kHz", "50 kHz",
            "100 kHz", "200 kHz", "500 kHz", "1 MHz", "2MHz", "5MHz",
            "10MHz", "20MHz", "40MHz" };
        
        
    }
    
    
    
    // ------------------------------------------------------------------------------------
    //     プログラムで使う色を集めたクラス
    // ------------------------------------------------------------------------------------
    public class clr
    {
        public static Color MeasBtnNor  = Color.LightPink;      // 測定ボタン　ノーマル
        public static Color MeasBtnExec = Color.Red;            // 測定ボタン　測定時
        
        // MDI
        public static Color MDIBG = Color.DimGray;//DarkOliveGreen;//Lavender;//AliceBlue;//DimGray;  // 背景色
        
        
        // SpeAna View で使用する色
        public static Color SAVScale = Color.DarkGray;          // 枠線、スケール
        public static Color SAVSubScale = Color.LightGray;      // サブスケール
        public static Color SAVName = Color.White;              // 文字
        public static Color SAVPictBG = Color.DarkSlateGray; //DimGray;//CadetBlue;//Tan;//SlateGray;//DimGray; // 外枠
        public static Color SAVGraphBG = Color.MintCream;       // グラフ領域
        
        
        // NetAna View で使用する色
        public static Color NAVScale = Color.DarkGray;          // 枠線、スケール
        public static Color NAVSubScale = Color.LightGray;      // サブスケール
        public static Color NAVName = Color.White;              // 文字
        public static Color NAVPictBG = Color.SlateGray;//DarkSlateGray;//DimGray; // 外枠
        public static Color NAVGraphBG = Color.MintCream;       // グラフ領域
        
        
        // ImpAna View で使用する色
        public static Color IAVScale = Color.DarkGray;          // 枠線、スケール
        public static Color IAVSubScale = Color.LightGray;      // サブスケール
        public static Color IAVName = Color.White;              // 文字
        public static Color IAVPictBG = Color.Olive;//Tan;//SlateGray;//DarkSlateGray;//DimGray; // 外枠
        public static Color IAVGraphBG = Color.MintCream;       // グラフ領域
        
        
        // FreqResponseGraphForm で使用する色
        public static Color FRGScale = Color.LightGray;//DarkGray;          // 枠線、スケール
        public static Color FRGScaleStrong = Color.DarkGray;//DarkSlateGray;  // 強調スケール
        public static Color FRGSubScale = Color.LightGray;      // サブスケール
        public static Color FRGName = Color.Black;              // 文字
        public static Color FRGStrong = Color.Red;              // 強調文字
        public static Color FRGPictBG = Color.LightGray;//LightYellow;//WhiteSmoke;//Gainsboro;//DimGray; // 外枠
        public static Color FRGGraphBG = Color.FromArgb(0xff,0xff,0xf0);//LightYellow;//MintCream;       // グラフ領域
        
        
        // Logiana で使用する色
        public static Color ViewBG = Color.LightGray;           // 背景色（標準）Beige Iv  
        public static Color SettingBG = Color.LightSteelBlue;   // 設定パネル背景色
        public static Color TextBack = Color.Beige;             // 設定パネルのテキスト背景
        public static Color Button0 = Color.Moccasin;           // ボタン（開始）
        public static Color Button1 = Color.LavenderBlush;      // ボタン（設定）
        public static Color Button2 = Color.Lavender;           // ボタン（カーソル）
        public static Color Button3 = Color.MistyRose;          // ボタン（カーソルハイライト

        public static Color FCFont = Color.Beige;               // 文字色
        public static Color FCBG = Color.LightSteelBlue;        // 背景色

        public static Color GraphBG = Color.LightGray;          // ウィンドウバックグラウンド色

        public static Color Name = Color.White;                 // 信号名色
        public static Color NameNormalBG = Color.FromArgb(0x45,0x57,0x75);//SlateGray;     // 信号名背景色（標準）
        public static Color NameHighlightBG = Color.FromArgb(0x65,0x77,0x85);//SteelBlue;  // 信号名背景色（ハイライト）
        public static Color WaveNormalBG = Color.White;         //MintCream; // 波形背景色（標準）
        public static Color WaveHighlightBG = Color.FromArgb(0xf0,0xff,0xff); //Color.LightCyan;  // 波形背景色（ハイライト）
        public static Color WaveLimitBG = Color.DarkGray;       //Thistle;//Goldenrod; // 波形背景色（アナログ波形範囲外）
        public static Color Wave = Color.DarkGreen;             // 波形色
        public static Color WaveValue = Color.Red; //Magenta;   // 波形値色
        public static Color WaveWidthDrag = Color.White;        // 波形幅ドラッグ挿入位置色
        public static Color WavePosDrag = Color.Red;            // 波形位置ドラッグ挿入位置色
        public static Color GndDrag = Color.Red;                // GND位置ドラッグ色
        public static Color WaveScale = Color.DarkGray;         //Color.LightGray;  // 波形スケール色
        public static Color WaveSubScale = Color.FromArgb(0xec,0xec,0xe8); //Color.LightGray;  波形サブスケール色
        //  public static Color AnalogWaveScale   = Color.DarkKhaki; // アナログ波形スケール色
        public static Color AnalogWaveScale = Color.LightGray;  // アナログ波形スケール色
        public static Color Cursor = Color.Blue;                // カーソル色（標準
        public static Color CursorNameBG = Color.Blue;          // カーソル名前背景色（標準
        public static Color CursorName = Color.White;           // カーソル名前色（標準）
        public static Color CursorHighlight = Color.Brown;      // カーソル色（ハイライト）
        public static Color CursorHighlightNameBG = Color.Brown; // カーソル名前背景色（ハイライト）
        public static Color CursorHighlightName = Color.White;  // カーソル名前色（ハイライト）

        public static Color TimeName = Color.White;             // 時間フォント色
        public static Color TimeBG = Color.FromArgb(0x45,0x57,0x75);//(0x58,0x50,0x80);//DarkSlateBlue;       // 時間スケール背景色
        public static Color TimeLine = Color.DarkKhaki;         // 時間スケール線色
        public static Color TrgMark = Color.Red;         // 時間スケールトリガーマーク色

        // 波形の色を順番に変えるための色テーブル
        public static Color[] Colortbl = new Color[] {          // 波形色テーブル
            Color.DodgerBlue, Color.Brown,  Color.Navy,      Color.Crimson,  Color.DarkOliveGreen, Color.DarkOrange,
            Color.LightSeaGreen,Color.DarkGreen,Color.RoyalBlue, Color.Magenta,
            Color.DarkCyan,  Color.Indigo,     Color.Purple,     Color.DeepPink,
            Color.Green,     Color.Red,        Color.Blue,       Color.LimeGreen,      
        };
        
        
        // OscilloView で使用する色
        public static Color OSVPictBG = Color.FromArgb(0xA0,0xB0,0xC0);//CadetBlue; //SlateGray;//DarkSlateGray;//DimGray; // 外枠
        
        
        public static int colorindex = 0;                       // 色を順番に変える
        
        public static Color getcolor(int idx)  {
            while (idx >= Colortbl.Length) idx -= Colortbl.Length;
            return Colortbl[idx];
        }
        
        public static Color getcolor()   {
            if (colorindex >= Colortbl.Length) colorindex = 0;
            return Colortbl[colorindex++];
        }

        public static Color colordialog(Color c) {
            using (ColorDialog colorDialog1 = new ColorDialog()) {
                colorDialog1.Color = c;                         // 初期選択色設定
                colorDialog1.FullOpen = true;                   // カスタム カラー表示
                if (colorDialog1.ShowDialog() == DialogResult.OK) { // OKの場合は選択した色に変更
                    return colorDialog1.Color;
                } else {
                    return c;
                }
            }
        }




    }




    // ------------------------------------------------------------------------------------
    //     プログラムで使うフォントを集めたクラス
    // ------------------------------------------------------------------------------------
    public class fnt
    {
        // TimeGraphForm で使用するフォント
        public static Font TGName = new Font("Courier", 8);       // 時間グラフ　信号名フォント
        public static Font TGScale = new Font("Courier New", 8);  // 時間グラフ　アナログ波高値スケールフォント
        public static Font TGCursor = new Font("Courier", 8);     // 時間グラフ　カーソルフォント
        public static Font TGWaveValue = new Font("Courier", 7);  // 時間グラフ　波形値フォント
        public static Font TGTime = new Font("Courier", 8);       // 時間グラフ　タイムスケール時間フォント
        
        // FreqResponseGraphForm で使用するフォント
        public static Font FRGnormal = new Font("Courier", 9);    // 周波数グラフ　通常使用フォント
        public static Font FRGmid = new Font("Courier", 7);       // 周波数グラフ　センター、スパン
        public static Font FRGsmall = new Font("Courier", 6);     // 周波数グラフ　対数周波数軸での補助数字
        public static Font FRGcursor = new Font("Courier", 8);    // 周波数グラフ　カーソルフォント
        
        // 
        public static Font Terminal = new Font("Courier", 8);     // ターミナルフォント
        
        // 
        public static Font FreqC = new Font("Courier", 18);       // 周波数表示フォント
        
    }





    // ------------------------------------------------------------------------------------
    //     共通で使うユーティリティを集めたクラス
    // ------------------------------------------------------------------------------------
    public class util
    {

        // str（16進、8進、2進） を int に変換（例外をスローしないよう wrap する）
        public static int ToInt32(string s, int radix)
        {
            try { return Convert.ToInt32(s, radix); }
            catch { return 0; }

        }

        // str を int に変換（例外をスローしないよう wrap する）
        public static int ToInt32(string s)
        {
            try { return Convert.ToInt32(s); }
            catch { return 0; }
        }

        // str を double に変換（例外をスローしないよう wrap する）
        public static double ToDouble(string s)
        {
            if (s.Length == 0) return 0;
            try { return Convert.ToDouble(s); }
            catch
            {
                string pre = s.Substring(s.Length - 1);       // 接頭語
                double val;
                try { val = Convert.ToDouble(s.Remove(s.Length - 1, 1)); }
                catch { return 0; }
                double preval = 1.0;
                switch (pre)
                {
                    case "G": preval = 1000000000; break;
                    case "M": preval = 1000000; break;
                    case "K": preval = 1000; break;
                    case "k": preval = 1000; break;
                    case "m": preval = 0.001; break;
                    case "u": preval = 1e-6; break;
                    case "n": preval = 1e-9; break;
                    case "p": preval = 1e-12; break;
                }
                return preval * val;
            }
        }

        // 1文字を16進数として変換　16進数文字でないときは 0 を返す
        public static int hex(char c)
        {
            if ((c >= '0') && (c <= '9')) return (c - '0');
            if ((c >= 'A') && (c <= 'F')) return (c - 'A' + 10);
            if ((c >= 'a') && (c <= 'f')) return (c - 'a' + 10);
            return 0;
        }


        // radix で指定された基数(2,8,10,16)の文字列に変換する。　１０進数だけはプロポーショナル
        // nbit は有効ビット数
        public static string Int2String(int val, int radix, int nbit)
        {
            string s = "";
            switch (radix)
            {
                case 2:
                    for (int i = 0; i < nbit; i++)
                    {
                        if ((val & 0x0001) != 0)
                        {
                            s = "1" + s;
                        }
                        else
                        {
                            s = "0" + s;
                        }
                        val = val >> 1;
                    }
                    break;
                case 8:
                    for (int i = 0; i < (nbit + 2) / 3; i++)
                    {
                        s = (val & 0x0007).ToString() + s;
                        val = val >> 3;
                    }
                    break;
                case 10:      // 符号なし１０進数
                    s = val.ToString();
                    break;
                case 11:      // 符号付き１０進数
                    int max = 1 << nbit;
                    if (val >= max / 2) val = val - max;       // マイナスの場合
                    s = val.ToString();
                    break;
                default:      // １６進数
                    for (int i = 0; i < (nbit + 3) / 4; i++)
                    {
                        s = (val & 0x000F).ToString("X") + s;
                        val = val >> 4;
                    }
                    break;
            }
            return s;
        }


        // double を文字列に変換（接頭なし）
        public static string Double2String_np(double d)
        {
            string s = (d < 0) ? "-" : "";
            if (d < 0) d = -d;
            if (d < 1e3) return s + d.ToString();
            else if (d < 1e6) return s + (d / 1e3).ToString();
            else return s + (d / 1e6).ToString();
        }


        // double を文字列に変換（接頭つき）
        public static string Double2String(double d)
        {
            if( d==0 ) return "0";
            
            string s = (d < 0) ? "-" : "";
            if (d < 0) d = -d;
            if      (d < 1e-9) return s + (d*1e12).ToString("#0.###") + "p";
            else if (d < 1e-6) return s + (d*1e9 ).ToString("#0.###") + "n";
            else if (d < 1e-3) return s + (d*1e6 ).ToString("#0.###") + "u";
            else if (d < 1   ) return s + (d*1e3 ).ToString("#0.###") + "m";
            else if (d < 1e3 ) return s +        d.ToString("#0.###");
            else if (d < 1e6 ) return s + (d/1e3 ).ToString("#0.###") + "k";
            else               return s + (d/1e6 ).ToString("#0.######") + "M";
        }


        // double を文字列に変換（接頭つき）桁数制限付き
        public static string Double2String_0(double d)
        {
            if( (d>-1e-13)&&(d<1e-13) ) return "0";
            
            string s = (d < 0) ? "-" : "";
            if (d < 0) d = -d;
            if      (d < 0.999e-8) return s + (d*1e12).ToString("#0") + "p";
            else if (d < 0.999e-5) return s + (d*1e9).ToString("#0") + "n";
            else if (d < 0.999e-2) return s + (d*1e6).ToString("#0") + "u";
            else if (d < 0.999   ) return s + (d*1e3).ToString("#0") + "m";
            else if (d < 1e4     ) return s + d.ToString("#0");
            else               return s + (d/1e3 ).ToString("#0") + "k";
        }


        // double を文字列に変換（接頭つき）桁数制限付き
        public static string Double2String_00(double d)
        {
            if( (d>-1e-13)&&(d<1e-13) ) return "0";
            
            string s = (d < 0) ? "-" : "";
            if (d < 0) d = -d;
            if      (d < 0.999e-8) return s + (d*1e12).ToString("#0.##") + "p";
            else if (d < 0.999e-5) return s + (d*1e9).ToString("#0.##") + "n";
            else if (d < 0.999e-2) return s + (d*1e6).ToString("#0.##") + "u";
            else if (d < 0.999   ) return s + (d*1e3).ToString("#0.##") + "m";
            else               return s + d.ToString("#0.##");
        }


        // double を文字列に変換（接頭つき）桁数制限付き
        public static string Double2String_000(double d)
        {
            string s = (d < 0) ? "-" : "";
            if (d < 0) d = -d;
            if (d < 1e3) return s + d.ToString("#0");
            else if (d < 1e6) return s + (d / 1e3).ToString("#0.###") + "k";
            else return s + (d / 1e6).ToString("#0.######") + "M";
        }


        // Freq を文字列に変換（接頭、単位つき）
        public static string Freq2Str(double freq)
        {
            string s = (freq < 0) ? "-" : "";
            if (freq < 0) freq = -freq;
            if (freq < 1e3) return s + freq.ToString("#0. 0 Hz");
            else if (freq < 1e6) return s + (freq / 1e3).ToString("#0. 000 KHz");
            else return s + (freq / 1e6).ToString("#0. 000 000 MHz");
        }
        
        
        public static string Time2FreqStr( double value, double clkperiod ) {
          string unit = "Ｈｚ";
          value = (value<0)? -value: value;
          double freq = (value>0)? 1/value: 0;
          if( freq >= 1e6 ) {
            freq /= 1e6;
            unit = "MHz";
          }else if( freq >= 1e3 ) {
            freq /= 1e3;
            unit = "kHz";
          }
          return String.Format("{0:#,##0.000} {1}", freq, unit );
        }
        
        
        public static string Time2Str( double value, double clkperiod ) {
          string unit = "";
          if( clkperiod < 1e-6 ) {
            value *= 1e9;
            unit = "ns";
          }else if( clkperiod < 1e-3 ) {
            value *= 1e6;
            unit = "us";
          }else{
            value *= 1e3;
            unit = "ms";
          }
          return String.Format("{0:#,##0} {1}", value, unit );
        }
        
        
        //
        //  ストップウオッチを文字列変換
        //
        public static string Sw2Str( Stopwatch sw ) {
          return ((double)sw.ElapsedTicks / (double)Stopwatch.Frequency * 1000).ToString("#0.0") + "msec";
        }
        
        
        
        
        
    }



    // ------------------------------------------------------------------------------------
    //     エラー定数を集めたクラス
    // ------------------------------------------------------------------------------------
    public class error {
        public const int noerr        = 0;
        public const int err          = -1;
        public const int invalid      = -2;
        public const int mes_noexec   = -3;
        public const int mes_interrupt= -4;
        public const int timeout      = -5;
        
        public const int usb_err      = -10;
        public const int usb_connect  = -11;
        public const int usb_invalid  = -12;
        public const int usb_timeout  = -13;
        public const int usb_readerr  = -14;
        public const int usb_writeerr = -15;
        public const int usb_mutex    = -16;
        public const int usb_disconnect = -17;
        
        public const int fpga_err     = -20;
        public const int fpga_config  = -21;
        public const int fpga_readerr = -22;
        public const int fpga_writeerr= -23;
        
        public const int df_err       = -30;
        public const int df_write     = -31;
        
        public const int op_err       = -40;
        
        
        public const string msg_err           = "E:エラー\n";
        public const string msg_invalid       = "E:不正な値\n";
        public const string msg_mes_noexec    = "E:実行できません\n";
        public const string msg_mes_interrupt = "E:測定が中断されました\n";
        
        public const string msg_usb_err       = "E:ＵＳＢ　エラー\n";
        public const string msg_usb_connect   = "E:ＵＳＢ　接続エラー\n";
        public const string msg_usb_invalid   = "E:ＵＳＢ　不正\n";
        public const string msg_usb_timeout   = "E:ＵＳＢ　タイムアウト\n";
        public const string msg_usb_readerr   = "E:ＵＳＢ　読み込みエラー\n";
        public const string msg_usb_writeerr  = "E:ＵＳＢ　書き込みエラー\n";
        public const string msg_usb_mutex     = "E:ＵＳＢ　ＭＵＴＥＸ取得エラー\n";
        public const string msg_usb_disconnect = "E:ＵＳＢ　エラー\n";
        
        public const string msg_fpga_err      = "E:ＦＰＧＡ　エラー\n";
        public const string msg_fpga_config   = "E:ＦＰＧＡ　コンフィグエラー\n";
        
        public const string msg_df_err        = "E:ＤＦ　エラー\n";
        public const string msg_dfwrite_err   = "E:ＤＦ　書き込みエラー\n";
        
        public const string msg_op_err        = "E:操作エラー\n";
        
        
        public static string msg( int errno ) {
          string errmsg;
          switch( errno ) {
            case err:           errmsg = msg_err;           break;
            case invalid:       errmsg = msg_invalid;       break;
            case mes_noexec:    errmsg = msg_mes_noexec;    break;
            case mes_interrupt: errmsg = msg_mes_interrupt; break;
            
            case usb_err:       errmsg = msg_usb_err;       break;
            case usb_connect:   errmsg = msg_usb_connect;   break;
            case usb_invalid:   errmsg = msg_usb_invalid;   break;
            case usb_timeout:   errmsg = msg_usb_timeout;   break;
            case usb_readerr:   errmsg = msg_usb_readerr;   break;
            case usb_writeerr:  errmsg = msg_usb_writeerr;  break;
            case usb_mutex:     errmsg = msg_usb_mutex;     break;
            case usb_disconnect: errmsg = msg_usb_disconnect;  break;
            
            case fpga_err:      errmsg = msg_fpga_err;      break;
            case fpga_config:   errmsg = msg_fpga_config;   break;
            
            case df_err:        errmsg = msg_df_err;        break;
            case df_write:      errmsg = msg_dfwrite_err;   break;
            
            case op_err:        errmsg = msg_op_err;        break;
            
            default:            errmsg = "E:未定義エラー";  break;
          }
          return errmsg;
        }
        
        // エラーメッセージダイアログ
        public static bool ErrorMessageBox(int errno) {
            string title = "", message = "";
            switch (errno) {
                case error.usb_connect:
                    title = "USBエラー";
                    message = "USB 接続でエラーがおきました。\r\rPCとの USB 接続や APB-3 基板の電源を確認してください。";
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                case error.usb_mutex:
                    title = "新たな測定実行エラー";
                    message = "他の測定を実行中のため新たな測定を開始できません。\r\r他のウィンドウでの測定を終了してから再度実行してください。";
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                case error.timeout:
                    title = "タイムアウト";
                    message = "測定がタイムアウトしました。\r\r信号との接続を確認してください。";
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                case error.usb_disconnect:
                    title = "通信エラー";
                    message = "APB-3 基板との通信でエラーがおきました。\r\rPCとの USB 接続や APB-3 基板の電源を確認してください。";
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                case error.mes_noexec:
                    title = "実行エラー";
                    message = "start 周波数は stop 周波数より低くないといけません。\r\rstart 周波数もしくは stop 周波数を修正してください。";
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                case error.mes_interrupt:
                    title = "測定中断";
                    message = "現在、測定中ですが中断しますか？";
                    return (MessageBox.Show(message, title, MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                case error.df_write:
                    title = "データフラッシュ書き込みエラー";
                    message = "データフラッシュへの書き込みでエラーがおきました。\r\rUSB 接続、電源などを確認の上、再度実行してください。";
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                case error.op_err:
                    title = "";
                    message = "現在測定中のためこの操作はできません。";
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                case error.fpga_config:
                    title = "ＦＰＧＡエラー";
                    message = "ＦＰＧＡのコンフィグでエラーが起きました。\r\rUSB 接続、電源などを確認の上、再度実行してください。";
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
                default:
                    title = "エラー";
                    message = error.msg( errno );
                    return (MessageBox.Show(message, title, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) == DialogResult.Yes);
            }
        }

    }

}

