--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   07:37:24 11/18/2011
-- Design Name:   
-- Module Name:   D:/ogchan/WorkShop/ISE/APB3/adc1610s_tb.vhd
-- Project Name:  APB3
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: adc1610s
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY adc1610s_tb IS
END adc1610s_tb;
 
ARCHITECTURE behavior OF adc1610s_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT adc1610s
    PORT(
         RESET : IN  std_logic;
         CLK : IN  std_logic;
         MCE : IN  std_logic;
         MWE : IN  std_logic;
         MADR : IN  std_logic_vector(15 downto 0);
         MWDATA : IN  std_logic_vector(7 downto 0);
         MRDATA : OUT  std_logic_vector(7 downto 0);
         ADC_CS_X : OUT  std_logic;
         ADC_SDIO_I : IN  std_logic;
         ADC_SDIO_O : OUT  std_logic;
         ADC_SDIO_Z : OUT  std_logic;
         ADC_SCLK : OUT  std_logic;
--         ADC_DAVP : IN  std_logic;
--         ADC_DAVN : IN  std_logic;
--         ADC_DATA : IN  std_logic_vector(15 downto 0);
--         ADC_OTR : IN  std_logic;
--         ADC_CLKP : OUT  std_logic;
         DEBUG : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal RESET : std_logic := '0';
   signal CLK : std_logic := '0';
   signal MCE : std_logic := '0';
   signal MWE : std_logic := '0';
   signal MADR : std_logic_vector(15 downto 0) := (others => '0');
   signal MWDATA : std_logic_vector(7 downto 0) := (others => '0');
   signal ADC_SDIO_I : std_logic := '0';
   signal ADC_DAVP : std_logic := '0';
   signal ADC_DAVN : std_logic := '0';
   signal ADC_DATA : std_logic_vector(15 downto 0) := (others => '0');
   signal ADC_OTR : std_logic := '0';

 	--Outputs
   signal MRDATA : std_logic_vector(7 downto 0);
   signal ADC_CS_X : std_logic;
   signal ADC_SDIO_O : std_logic;
   signal ADC_SDIO_Z : std_logic;
   signal ADC_SCLK : std_logic;
   signal ADC_CLKP : std_logic;
   signal DEBUG : std_logic;

   -- Clock period definitions
   constant CLK_period : time := 10 ns;
--   constant ADC_SCLK_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: adc1610s PORT MAP (
          RESET => RESET,
          CLK => CLK,
          MCE => MCE,
          MWE => MWE,
          MADR => MADR,
          MWDATA => MWDATA,
          MRDATA => MRDATA,
          ADC_CS_X => ADC_CS_X,
          ADC_SDIO_I => ADC_SDIO_I,
          ADC_SDIO_O => ADC_SDIO_O,
          ADC_SDIO_Z => ADC_SDIO_Z,
          ADC_SCLK => ADC_SCLK,
--          ADC_DAVP => ADC_DAVP,
--          ADC_DAVN => ADC_DAVN,
--          ADC_DATA => ADC_DATA,
--          ADC_OTR => ADC_OTR,
--          ADC_CLKP => ADC_CLKP,
          DEBUG => DEBUG
        );

   -- Clock process definitions
   CLK_process :process
   begin
		CLK <= '0';
		wait for CLK_period/2;
		CLK <= '1';
		wait for CLK_period/2;
   end process;
 
--   ADC_SCLK_process :process
--   begin
--		ADC_SCLK <= '0';
--		wait for ADC_SCLK_period/2;
--		ADC_SCLK <= '1';
--		wait for ADC_SCLK_period/2;
--   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      RESET <= '1';
      MCE <= '0';
      MWE <= '0';
      wait for CLK_period*2;	
      RESET <= '0';
      MCE   <= '1';
      ADC_SDIO_I <= '0';
      wait for CLK_period;
      
      MADR   <= X"0001";      -- ADRS
      MWDATA <= X"B5";
      wait for CLK_period;
      MWE    <= '1';
      wait for CLK_period;
      MWE    <= '0';
      
      MADR   <= X"0002";      -- DATA
      MWDATA <= X"05";
      wait for CLK_period;
      MWE    <= '1';
      wait for CLK_period;
      MWE    <= '0';
      
      MADR   <= X"0000";      -- START SPI
      MWDATA <= X"01";
      wait for CLK_period;
      MWE    <= '1';
      wait for CLK_period;
      MWE    <= '0';
      
      wait for CLK_period*8*20;
      ADC_SDIO_I <= '1';
      wait for CLK_period*8*8;
      
      
      MADR   <= X"0000";      -- START SPI
      MWDATA <= X"01";
      wait for CLK_period;
      MWE    <= '1';
      wait for CLK_period;
      MWE    <= '0';
--      wait for CLK_period*8*24;
      
      
      wait for CLK_period*20;
      assert (false) report "Simulation End!" severity failure;
   end process;

END;
