----------------------------------------------------------------------------------
--  
--        apb-3_top.vhd        APB-3 top Kw
--  
--        (c)2011/08/20  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;



entity apb_3_top is
  port (
    EXTCLK100 : in  std_logic;                        -- 100MHz NbN    P14/GCLK20  
    RESET_X   : in  std_logic;                        -- _Zbg         P143         
    
    FT_DATA   : inout std_logic_vector (7 downto 0);  -- FT232H D0..7           P43..48 61..65
    FT_RXF_X  : in  std_logic;                        -- FT232H RXF#            P50
    FT_TXE_X  : inout std_logic;                      -- FT232H TXE# (DF SCK)   P70
    FT_RD_X   : inout std_logic;                      -- FT232H RD#             P51
    FT_WR_X   : out std_logic;                        -- FT232H WR#             P55
    FT_SIWU_X : out std_logic;                        -- FT232H SIWU#           P57
    FT_CLK    : in  std_logic;                        -- FT232H CLKOUT          P56
    FT_OE_X   : out std_logic;                        -- FT232H OE#             P39(INIT_B)
    --    P39(INIT_B)  user I/O ƂĎgpɂ CONFIG POST_CRC = Disable;  ucf ɋLqKv
    
    DF_CS_X   : out std_logic;                        -- AT25DF041 CS#          P38
    DF_SI     : out std_logic;                        -- AT25DF041 SI           P64
    
    UDA_L3MODE: out std_logic;                        -- UDA1345 MP2(L3MODE)    P40
    UDA_L3CLK : out std_logic;                        -- UDA1345 MP3(L3CLK)     P35
    UDA_L3DATA: out std_logic;                        -- UDA1345 MP4(L3DATA)    P29
    UDA_SYSCLK: out std_logic;                        -- UDA1345 SYSCLK         P41
    UDA_BCK   : out std_logic;                        -- UDA1345 BCK            P30
    UDA_WS    : out std_logic;                        -- UDA1345 WS             P32
    UDA_DATAO : in  std_logic;                        -- UDA1345 DATAO          P33
    UDA_DATAI : out std_logic;                        -- UDA1345 DATAI          P34
    
    ADC_CS_X  : out std_logic;                        -- ADC1610 CS#            P121    P119
    ADC_SDIO  : inout std_logic;                      -- ADC1610 SDIO           P123    P120
    ADC_SCLK  : out std_logic;                        -- ADC1610 SCLK           P124    P121
    ADC_DATAIN: in  std_logic_vector (15 downto 0);   -- ADC1610 D0..15         P126..6
    ADC_OTR   : in  std_logic;                        -- ADC1610 OTR            P7
    ADC_CLKP  : in std_logic;                        -- ADC1610 CLKP           P8
    
    DAC_DATA  : out std_logic_vector (13 downto 0);   -- AD9707 D0..13          P87..105   P85..104
    DAC_CLK   : in  std_logic;                        -- AD9707 CLK             P84
    DAC_PIN   : out std_logic;                        -- AD9707 PIN             P81
    DAC_MODE  : out std_logic;                        -- AD9707 MODE            P82
    DAC_CMODE : out std_logic;                        -- AD9707 CMODE           P83
    
    CN9       : inout std_logic_vector (14 downto 4); -- CN9   STM32F103        P11..27
    CN12      : inout std_logic_vector (3 downto 0);  -- CN12  PRE-1            P74..79
    
    CN14      : inout std_logic_vector (8 downto 0);  -- CN14                   P111..120       PCB v3
    
    LED       : out std_logic;                        -- LED                    P80
    
    -- ȉ͖gps -------------------------------------------------------------------------------
    ADC_DAVP  : in  std_logic;                        -- ADC1610 DAVP           P123       PCB v2
    ADC_DAVN  : in  std_logic;                        -- ADC1610 DAVN           P124       PCB v2
    P47       : in std_logic;                     -- =RDWR=L
    P58       : in std_logic;       -- check land
    P59       : in std_logic;       -- check land
    P60       : in std_logic;                     -- =M1
    P66       : in std_logic;       -- check land
    P67       : in std_logic;       -- check land
    P69       : in std_logic;                     -- =M0
    P85       : in std_logic;                     -- 
    P144      : in std_logic                      -- =HSWAPEN=L
    
  );
end apb_3_top;


architecture RTL of apb_3_top is
  
  signal RESET        : std_logic;
  signal EXTCLK100_IBUFG : std_logic;
  signal EXTCLK100_BUFG  : std_logic;
  signal CLK100       : std_logic;
  signal CLK100_90    : std_logic;
  signal CLK100_180   : std_logic;
  signal CLK100_270   : std_logic;
  
  --  Clk Counter 32bits
  signal CNT32      : std_logic_vector (31 downto 0);
  
  --  FT232H
  signal MWE      : std_logic;                        -- Module Write Enable
  signal MRE      : std_logic;                        -- Module Read Enable
  signal MCE      : std_logic_vector(15 downto 0);    -- Module Chip Enable
  signal MWDATA   : std_logic_vector( 7 downto 0);    -- W[݃f[^
  signal MRDATA   : std_logic_vector( 7 downto 0);    -- W[ǂݏof[^
  signal MADR     : std_logic_vector(15 downto 0);    -- W[AhX
  signal DF_CS_X1 : std_logic;    -- DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG 
  signal DF_SI1   : std_logic;    -- DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG 
  
  -- fconv
  signal ISIG1    : std_logic_vector(17 downto 0);    -- 
  signal QSIG1    : std_logic_vector(17 downto 0);    -- 
  
  
  --  M0:Signature
  signal SIG_MRDATA : std_logic_vector( 7 downto 0);   -- Signature ǂݏof[^
  
  --  M1:DDS
  signal COS       : std_logic_vector(17 downto 0);   -- dds1 o
  signal SIN       : std_logic_vector(17 downto 0);   -- dds1 o
  signal DDS1      : std_logic_vector (17 downto 0);
  signal DDS_L     : std_logic_vector(15 downto 0);   -- dds3 o
  signal DDS_R     : std_logic_vector(15 downto 0);   -- dds3 o
  signal AMP       : std_logic_vector(17 downto 0);   -- `lϒEUiۂ̏DACubNj
  
  -- M2:cic
  signal ISIG2    : std_logic_vector(19 downto 0);    -- 
  signal QSIG2    : std_logic_vector(19 downto 0);    -- 
  signal CIC_WEN  : std_logic;                        -- 
  signal MWISIG   : std_logic_vector(15 downto 0);    -- 
  signal MWQSIG   : std_logic_vector(15 downto 0);    -- 
  
  --  M3:ADC1610S
  signal ADCDATA   : std_logic_vector(15 downto 0);   -- ADC f[^
  signal ADC_MRDATA : std_logic_vector( 7 downto 0);   -- ADC ǂݏof[^
  
  --  M4:AD9797
  
  --  M6:UDA1345
  signal UDA_MRDATA : std_logic_vector( 7 downto 0);  -- ǂݏof[^
  signal SCK        : std_logic;                      -- 
  signal L3MODE     : std_logic;                      -- 
  signal L3CLK      : std_logic;                      -- 
  signal L3DATA     : std_logic;                      -- 
  signal BCK        : std_logic;                      -- 
  signal LRCK       : std_logic;                      -- 
  signal I2SOUT     : std_logic;                      -- 
  
  --  M7:MEMORY
  signal MEM_MRDATA : std_logic_vector( 7 downto 0);   -- MEMORY ǂݏof[^
  signal CIC_WDATA : std_logic_vector(39 downto 0);   -- ݃f[^ 0
  signal CIC_WE    : std_logic;                       -- ݃^C~O 0
  
  --  M8:FREQ_DET
  signal FM_MRDATA    : std_logic_vector( 7 downto 0); -- FREQ_DET ǂݏof[^
  signal FM_DETOUT    : std_logic_vector(15 downto 0); -- FM
  signal FM_MEMWDATA  : std_logic_vector(31 downto 0); -- ݃f[^ 1
  signal FM_MEMWE     : std_logic;                     -- ݃^C~O 1
  signal FM_TRG       : std_logic;                     -- ݃^C~O
  
  --  M10:DEMOD
  signal MEME       : std_logic;                      -- IIR 0x7000-0x7FFF
  signal DEMOD_MRDATA : std_logic_vector( 7 downto 0);-- DEMOD ǂݏof[^
  signal DEMOD_L    : std_logic_vector( 17 downto 0); -- DEMOD Lch o
  signal DEMOD_R    : std_logic_vector( 17 downto 0); -- DEMOD Rch o
  
  --  M11:oscilloscope
  signal OSC_TRG    : std_logic;                      -- gK[
  
  ------------------------------------------------------------------------------
  
  
  component dcm_100M
  port (
    -- Clock in ports
    CLK_IN1           : in     std_logic;
    -- Clock out ports
    CLK_OUT1          : out    std_logic;
    CLK_OUT2          : out    std_logic;
    CLK_OUT3          : out    std_logic;
    CLK_OUT4          : out    std_logic;
    -- Status and control signals
    RESET             : in     std_logic;
    LOCKED            : out    std_logic
  );
  end component;
  
  
  component counter32
  port (
    RESET   : in  std_logic;                      -- 񓯊Zbg
    CLK     : in  std_logic;                      -- clock
    COUNT   : out std_logic_vector(31 downto 0 )  -- JEgl
  );
  end component;
  
  
  component ft232h
  port (
    RESET       : in  std_logic;
    CLK         : in  std_logic;                      -- I/O bus clock
    
    FT232_RXF_X : in  std_logic;                      -- FT232 RXF#
    FT232_TXE_X : inout std_logic;                    -- FT232 TXE#   (out DF_SCK)
    FT232_RD_X  : out std_logic;                      -- FT232 RD_X#
    FT232_WR_X  : out std_logic;                      -- FT232 WR_X#
    FT232_SIWU_X: out std_logic;                      -- FT232 SIWU#  (send immediate)
    FT232_OE_X  : out std_logic;                      -- FT232 OE#
    FT232_CLK   : in  std_logic;                      -- FT232 CLKOUT
    FT232_DATA  : inout std_logic_vector(7 downto 0);   -- FT232 data bus o
    
    DF_CS_X     : out std_logic;                      -- AT25DF041 CS#          P38
    DF_SI       : out std_logic;                      -- AT25DF041 SI           P64
    
    MWE         : out std_logic;                      -- Module Write Enable
    MRE         : out std_logic;                      -- Module Read Enable
    MCE         : out std_logic_vector(15 downto 0);  -- Module Enable
    MWDATA      : out std_logic_vector( 7 downto 0);  -- W[݃f[^
    MRDATA      : in  std_logic_vector( 7 downto 0);  -- W[ǂݏof[^
    MADR        : out std_logic_vector(15 downto 0 ); -- W[AhX
    
    FTDEBUG     : out std_logic_vector( 4 downto 0 )  -- DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG 
    
  );
  end component;
  
  
  component fconv   -- gϊ
    port (
      RESET   : in  STD_LOGIC;
      CLK     : in  STD_LOGIC;
      SIGIN   : in  STD_LOGIC_VECTOR (15 downto 0);   -- ADf[^
      ILOIN   : in  STD_LOGIC_VECTOR (17 downto 0);   -- LO
      QLOIN   : in  STD_LOGIC_VECTOR (17 downto 0);
      IOUT    : out STD_LOGIC_VECTOR (17 downto 0);   -- o
      QOUT    : out STD_LOGIC_VECTOR (17 downto 0)
    );
  end component;
  
  
  component signature 
  port (
    CLK      : in  std_logic;                      -- I/O clock
    
    MCE      : in  std_logic;                      -- module select
    MWE      : in  std_logic;                      -- Module Write Enable
    MADR     : in  std_logic_vector(15 downto 0);  -- address bus
    MWDATA   : in  std_logic_vector( 7 downto 0);  -- W[݃f[^
    MRDATA   : out std_logic_vector( 7 downto 0)   -- data bus output
  );
  end component;
  
  
  component dds
  port (
    RESET   : in  std_logic;
    IOCLK   : in  std_logic;                      -- io bus clock
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MADR    : in  std_logic_vector(15 downto 0 ); -- W[AhX
    MWDATA  : in  std_logic_vector( 7 downto 0 ); -- W[֏ރf[^
    
    DDSCLK  : in  std_logic;
    
    AMP     : out std_logic_vector(17 downto 0);  -- `lϒEUiۂ̏AD9707ubNj
    
    COS0    : out std_logic_vector(17 downto 0);  -- ccrO@o
    SIN0    : out std_logic_vector(17 downto 0);
    
    SIG1    : out std_logic_vector(17 downto 0);  -- ccrP@o
    
    SIG2    : out std_logic_vector(15 downto 0);  -- ccrQ@o
    
    SIG3    : out std_logic_vector(15 downto 0)   -- ccrR@o
  );
  end component;
  
  
  component cic
  port (
    RESET   : in  std_logic;
    IOCLK   : in  std_logic;                      -- io bus clock
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MADR    : in  std_logic;                      -- W[AhX
    MWDATA  : in  std_logic_vector( 7 downto 0 ); -- W[֏ރf[^
    
    CLK        : in  std_logic;
    DATA_I_IN  : in  std_logic_vector( 17 downto 0); -- ̓f[^
    DATA_Q_IN  : in  std_logic_vector( 17 downto 0); -- ̓f[^
    DATA_I_OUT : out std_logic_vector( 19 downto 0); -- o̓f[^
    DATA_Q_OUT : out std_logic_vector( 19 downto 0); -- o̓f[^
    WEN        : out std_logic;                      -- o̓f[^݃^C~O
    DEBUG      : out std_logic_vector( 7 downto 0)
  );
  end component;
  
  
  component fix2float
  port (
    CLK     : in  std_logic;                      -- 
    FIX20   : in  std_logic_vector( 19 downto 0); -- ̓f[^
    FLOAT16 : out std_logic_vector( 15 downto 0)  -- o̓f[^
  );
  end component;
  
  
  component adc1610s
  port (
    RESET     : in  std_logic;
    CLK       : in  std_logic;                      -- 90x clock
    CLK_90    : in  std_logic;                      -- 90x clock
    CLK_180   : in  std_logic;                      -- ]clock
    CLK_270   : in  std_logic;                      -- 270x clock
    MCE       : in  std_logic;                      -- module select
    MWE       : in  std_logic;                      -- Module Write Enable
    MRE       : in  std_logic;                      -- Module Read Enable
    MADR      : in  std_logic_vector(15 downto 0);  -- address bus
    MWDATA    : in  std_logic_vector( 7 downto 0);  -- W[݃f[^
    MRDATA    : out std_logic_vector( 7 downto 0);  -- data bus output
    
    ADC_CS_X  : out std_logic;                      -- ADC1610 CS#            P121
    ADC_SDIO  : inout  std_logic;                   -- ADC1610 SDIO           P123
    ADC_SCLK  : out std_logic;                      -- ADC1610 SCLK           P124
    
    ADC_DATAIN: in  std_logic_vector (15 downto 0);   -- ADC1610 D0..15         P126..6
    ADC_OTR   : in  std_logic;                        -- ADC1610 OTR            P7
    ADC_CLKP  : in std_logic;                        -- ADC1610 CLKP           P8
    
    ADCDATA   : out std_logic_vector (15 downto 0);   -- 
    
    DEBUG     : out std_logic
  );
  end component;
  
  
  component ad9707
  port (
    RESET   : in  STD_LOGIC;
    CLK     : in  STD_LOGIC;
    CLK_180 : in  STD_LOGIC;
    MCE     : in  std_logic;                        -- Module Chip Enable
    MWE     : in  STD_LOGIC;
    MWDATA  : in  STD_LOGIC_VECTOR (7 downto 0);    -- 0  0:dds0  1:dds1
    
    AMP     : in  std_logic_vector (17 downto 0);   -- `lϒEUx
    DDS0_IN : in  STD_LOGIC_VECTOR (17 downto 0);   -- DDS0́@2̕␔\
    DDS1_IN : in  STD_LOGIC_VECTOR (17 downto 0);   -- DDS1́@2̕␔\
    DAC_DATA  : out STD_LOGIC_VECTOR (13 downto 0); -- AD9707 DATA@Ȃ\
    DAC_CLK   : in  std_logic;                      -- AD9707 CLK             P84
    DAC_PIN   : out std_logic;                      -- AD9707 PIN             P81
    DAC_MODE  : out std_logic;                      -- AD9707 MODE            P82
    DAC_CMODE : out std_logic                       -- AD9707 CMODE           P83
  );
  end component;
  
  
  component uda1345
  port (
    RESET   : in  std_logic;
    CLK     : in  std_logic;                      -- 100MHz
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MRE     : in  std_logic;                      -- Module Read Enable
    MADR    : in  std_logic_vector(15 downto 0);  -- W[AhX
    MWDATA  : in  std_logic_vector(7 downto 0);   -- data bus input
    MRDATA  : out std_logic_vector(7 downto 0);   -- data bus output
    
    CNT32   : in  std_logic_vector(31 downto 0);  -- 32bit counter
    
    D0_IN   : in  std_logic_vector(15 downto 0);  -- ̓f[^ 0 ( DDS2 )
    D1_IN   : in  std_logic_vector(15 downto 0);  -- ̓f[^ 1 ( DDS3 )
    D2_IN   : in  std_logic_vector(15 downto 0);  -- ̓f[^ 2 ( DEMOD_OUT )
    D4_IN   : in  std_logic_vector(15 downto 0);  -- ̓f[^ 4 ( FMDEMOD_OUT )
    I_IN    : in  std_logic_vector(15 downto 0);  -- ̓f[^ 3 ( I M )
    Q_IN    : in  std_logic_vector(15 downto 0);  -- ̓f[^ 3 ( Q M )
    
    L_OUT   : out std_logic_vector(15 downto 0);  -- I[fBI Lch A/D o
    R_OUT   : out std_logic_vector(15 downto 0);  -- I[fBI Rch A/D o
    ND      : out std_logic;                      -- I[fBI A/D ϊo L
    
    SCK     : out std_logic;                      -- 256fs =25MHz    =CLK/4
    BCK     : out std_logic;                      -- 32fs  =3.125MHz =CLK/32
    LRCK    : out std_logic;                      -- fs    =97.656KHz =CLK/1024  L='0' R='1'
    I2SOUT  : out std_logic;                      -- I2S data out (MSB first)
    I2SIN   : in  std_logic;                      -- I2S data in (MSB first)
    
    L3MODE  : out std_logic;                      -- MP2
    L3CLK   : out std_logic;                      -- MP3  2MHzmax
    L3DATA  : out std_logic                       -- MP4
  );
  end component;
  
  
  component memcontrol
  port (
    RESET     : in  STD_LOGIC;
    CLK       : in  STD_LOGIC;
    MCE       : in  STD_LOGIC;
    MWE       : in  STD_LOGIC;
    MADR      : in  STD_LOGIC_VECTOR (15 downto 0);
    MWDATA    : in  STD_LOGIC_VECTOR (7 downto 0);
    MRDATA    : out  STD_LOGIC_VECTOR (7 downto 0);
    
    MEMDATAIN0: in  STD_LOGIC_VECTOR (39 downto 0);
    MEMDATAIN1: in  STD_LOGIC_VECTOR (39 downto 0);
    MEMDATAOUT: out STD_LOGIC_VECTOR (39 downto 0);
    MEMWE0    : in  STD_LOGIC;
    MEMWE1    : in  STD_LOGIC;
    TRG0      : in  STD_LOGIC;
    TRG1      : in  STD_LOGIC
  );
  end component;
  
  
  component freqdet
  port (
    RESET   : in  std_logic;                      -- 
    CLK     : in  std_logic;
    
    MCE     : in  std_logic;                      -- Cl[u
    MWE     : in  std_logic;                      -- 
    MADR    : in  std_logic_vector(15 downto 0);  -- AhX
    MWDATA  : in  std_logic_vector( 7 downto 0);  -- ރf[^
    MRDATA  : out std_logic_vector( 7 downto 0);  -- ǂݏof[^
    
    CNT32   : in std_logic_vector(31 downto 0);   -- t[JE^[l
    
    DSIGIN  : in std_logic_vector(7 downto 0);    -- MfW^
    ASIGIN  : in std_logic_vector(15 downto 0);   -- AiO( ADC1610 o )
    
    I_IN    : in std_logic_vector(17 downto 0);   -- gϊ CIC ʂM
    Q_IN    : in std_logic_vector(17 downto 0);
    ND      : in  std_logic;                      -- I_IN, Q_IN L
    
    DET_OUT : out std_logic_vector (15 downto 0);   -- FMo
    MEMWDATA : out std_logic_vector (31 downto 0);  -- [ݗpf[^o
    MEMWE    : out std_logic;                       -- lݗL
    TRG      : out std_logic                        -- gK[
  );
  end component;
  
  
  component demod
  port (
    RESET   : in  std_logic;
    CLK     : in  std_logic;                      -- 100MHz
    MEME    : in  std_logic;                      -- Memory Enable
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MRE     : in  std_logic;                      -- Module Read Enable
    MADR    : in  std_logic_vector(15 downto 0);  -- W[AhX
    MWDATA  : in  std_logic_vector(7 downto 0);   -- data bus input
    MRDATA  : out std_logic_vector(7 downto 0);   -- data bus output
    
    I_IN    : in  std_logic_vector(32 downto 0);  -- I M
    Q_IN    : in  std_logic_vector(32 downto 0);  -- Q M
    
    L_OUT   : out std_logic_vector(17 downto 0);  -- L Mo
    R_OUT   : out std_logic_vector(17 downto 0)   -- R Mo
    
  );
  end component;
  
  component oscilloscope
  port (
    RESET   : in  std_logic;                      -- 
    CLK     : in  std_logic;
    
    MCE     : in  std_logic;                      -- Cl[u
    MWE     : in  std_logic;                      -- 
    MADR    : in  std_logic_vector(15 downto 0);  -- AhX
    MWDATA  : in  std_logic_vector( 7 downto 0);  -- ރf[^
    
    I_IN    : in std_logic_vector(17 downto 0);   -- gϊ CIC ʂM
    Q_IN    : in std_logic_vector(17 downto 0);
    ND      : in  std_logic;                      -- I_IN, Q_IN L
    
    DSIGOUT : out std_logic;                     -- g``ăfW^M
    TRG     : out std_logic                      -- gK[
    
  );
  end component;
  
  
begin
  
  ------------------------------------------------------------------------------------------
  --  DCM
  ------------------------------------------------------------------------------------------
  D0 : dcm_100M
  port map(
    -- Clock in ports
    CLK_IN1 => EXTCLK100,
    -- Clock out ports
    CLK_OUT1 => CLK100_180,
    CLK_OUT2 => CLK100_270,
    CLK_OUT3 => CLK100,
    CLK_OUT4 => CLK100_90,
    -- Status and control signals
    RESET  => RESET,
    LOCKED => open
  );
  
  
  ------------------------------------------------------------------------------------------
  --  Clk Counter 32bits
  ------------------------------------------------------------------------------------------
  U0: counter32
  port map(
    RESET   => RESET,                   -- 񓯊Zbg
    CLK     => CLK100,                  -- clock
    COUNT   => CNT32                    -- JEgl
  );
  
  
  
  ------------------------------------------------------------------------------------------
  --  FT232H
  ------------------------------------------------------------------------------------------
  U1: ft232h
  port map(
    RESET       => RESET,               -- 񓯊Zbg
    CLK         => CLK100,              -- I/O bus clock
    
    FT232_RXF_X => FT_RXF_X,            -- FT232 RXF#
    FT232_TXE_X => FT_TXE_X,            -- FT232 TXE#
    FT232_RD_X  => FT_RD_X,             -- FT232 RD_X#
    FT232_WR_X  => FT_WR_X,             -- FT232 WR_X#
    FT232_SIWU_X=> FT_SIWU_X,           -- FT232 SIWU#  send immediate
    FT232_OE_X  => FT_OE_X,             -- FT232 OE#  
    FT232_CLK   => FT_CLK,              -- FT232 CLKOUT
    FT232_DATA  => FT_DATA,             -- FT232 data bus o
    
    DF_CS_X     => DF_CS_X,             -- AT25DF041 CS#          P38
    DF_SI       => DF_SI,               -- AT25DF041 SI           P64
    
    MWE         => MWE,                 -- Module Write Enable
    MRE         => MRE,                 -- Module Read Enable
    MCE         => MCE,                 -- Module Enable
    MWDATA      => MWDATA,              -- W[݃f[^
    MRDATA      => MRDATA,              -- W[ǂݏof[^
    MADR        => MADR,                -- W[AhX
    
    FTDEBUG     => open
  );
  
  MRDATA <= SIG_MRDATA or ADC_MRDATA or FM_MRDATA or MEM_MRDATA or DEMOD_MRDATA;
  
  
  ------------------------------------------------------------------------------------------
  --  Frequency Converter  gϊ
  ------------------------------------------------------------------------------------------
  U4: fconv
  port map (
    RESET    => RESET,
    CLK      => CLK100,
    SIGIN    => ADCDATA,      -- <= ADC1610
    ILOIN    => COS,          -- <= DDS
    QLOIN    => SIN,          -- <= DDS
    IOUT     => ISIG1,        -- => CIC
    QOUT     => QSIG1         -- => CIC
  );
  
  
  ------------------------------------------------------------------------------------------
  --  Signature
  ------------------------------------------------------------------------------------------
  M0 : signature
  port map (
    CLK      => CLK100,
    
    MCE      => MCE(0),                 -- Module Chip Enable  Addrs=0x00xx
    MWE      => MWE,                    -- Module Write Enable
    MADR     => MADR,                   -- W[AhX
    MWDATA   => MWDATA,                 -- W[݃f[^
    MRDATA   => SIG_MRDATA              -- W[ǂݏof[^
  );
  
  
  ------------------------------------------------------------------------------------------
  --  DDS
  ------------------------------------------------------------------------------------------
  M1 : dds
  port map(
    RESET    => RESET,                  -- 
    IOCLK    => CLK100,                 -- 
    
    MCE      => MCE(1),                 -- Addrs=0x01xx
    MWE      => MWE,                    -- write
    MADR     => MADR,                   -- W[AhX
    MWDATA   => MWDATA,                 -- W[݃f[^
    
    DDSCLK   => CLK100,                 -- 
    AMP      => AMP,         -- =>     `lϒEUiۂ̏DACubNj
    
    COS0     => COS,          -- => fconv, ad9707   ccrO@o
    SIN0     => SIN,          -- => fconv,
    SIG1     => DDS1,         -- => ad8707          ccrP@o
    SIG2     => DDS_L,        -- => uda1345         ccrQ@o
    SIG3     => DDS_R         -- => uda1345         ccrR@o
  );
  
  
  ------------------------------------------------------------------------------------------
  --  CIC( decimation )
  ------------------------------------------------------------------------------------------
  M2 : cic
  port map(
    RESET   => RESET,
    IOCLK   => CLK100,
    MCE     => MCE(2),              -- Module Chip Enable  Addrs=0x02xx
    MWE     => MWE,
    MADR    => MADR(0),
    MWDATA  => MWDATA,
    
    CLK        => CLK100,
    DATA_I_IN  => ISIG1,        -- <= fconv
    DATA_Q_IN  => QSIG1,        -- <= fconv
    DATA_I_OUT => ISIG2,        -- => (fir)demod, uda1345, freq_det
    DATA_Q_OUT => QSIG2,        -- => (fir)demod, uda1345, freq_det
    WEN        => CIC_WEN,      -- => cic
    DEBUG      => open
  );
  
  CIC_WDATA <= QSIG2(3 downto 0) & ISIG2(3 downto 0) & QSIG2(19 downto 4) & ISIG2(19 downto 4);
  
  
  ------------------------------------------------------------------------------------------
  --  ADC1610S (ADC)
  ------------------------------------------------------------------------------------------
  M3 : adc1610s
  port map(
    RESET    => RESET,                  -- 
    CLK      => CLK100,                 -- 
    CLK_90   => CLK100_90,              -- 
    CLK_180  => CLK100_180,             -- 
    CLK_270  => CLK100_270,             -- 
    
    MCE      => MCE(3),                 -- Addrs=0x03xx
    MWE      => MWE,                    -- write enable
    MRE      => MRE,                    -- read enable
    MADR     => MADR,                   -- W[AhX
    MWDATA   => MWDATA,                 -- W[݃f[^
    MRDATA   => ADC_MRDATA,             -- W[ǂݏof[^
    
    ADC_CS_X   => ADC_CS_X,             -- ADC1610 CS#            P121
    ADC_SDIO   => ADC_SDIO,             -- ADC1610 SDIO_IN        P123
    ADC_SCLK   => ADC_SCLK,             -- ADC1610 SCLK           P124
    
    ADC_DATAIN => ADC_DATAIN,           -- ADC1610 D0..15         P126..6
    ADC_OTR    => ADC_OTR,              -- ADC1610 OTR            P7
    ADC_CLKP   => ADC_CLKP,             -- ADC1610 CLKP           P8
    
    ADCDATA    => ADCDATA,              -- => fconv
    
    DEBUG      => open
  );
  
  
  ------------------------------------------------------------------------------------------
  --  AD9707 (DAC)
  ------------------------------------------------------------------------------------------
  M4 : ad9707
  port map(
    RESET   => RESET,
    CLK     => CLK100,
    CLK_180 => CLK100_180,
    MCE     => MCE(4),              -- Module Chip Enable  Addrs=0x04xx
    MWE     => MWE,
    MWDATA  => MWDATA,              -- o͑I  0:dds0  1:dds1
    
    AMP     => AMP,                 -- <= dds     `lϒEU
    
    DDS0_IN   => COS(17 downto 0),  -- <= dds     DDS0́@2̕␔\
    DDS1_IN   => DDS1(17 downto 0), -- <= dds     DDS1́@2̕␔\
    DAC_DATA  => DAC_DATA,          -- AD9707 DATA@Q̕␔\g
    DAC_CLK   => DAC_CLK,           -- AD9707 CLK             P84
    DAC_PIN   => DAC_PIN,           -- AD9707 PIN             P81
    DAC_MODE  => DAC_MODE,          -- AD9707 MODE            P82
    DAC_CMODE => DAC_CMODE          -- AD9707 CMODE           P83
  );
  
  
  ------------------------------------------------------------------------------------------
  --  Audio ADC/DAC   UDA1345
  ------------------------------------------------------------------------------------------
  M6 : uda1345
  port map(
    RESET   => RESET,
    CLK     => CLK100,
    MCE     => MCE(6),        -- Module Chip Enable  Addrs=0x06xx
    MWE     => MWE,
    MRE     => MRE,
    MADR    => MADR,          -- W[AhX
    MWDATA  => MWDATA,        -- 
    MRDATA  => UDA_MRDATA,    -- data bus output
    
    CNT32   => CNT32,         -- 32bit counter
    
    D0_IN   => DDS_L,         -- <= dds     ̓f[^ 0 ( DDS2 )
    D1_IN   => DDS_R,         -- <= dds     ̓f[^ 1 ( DDS3 )
    D2_IN   => DEMOD_L(17 downto 2), -- <= DEMOD   ̓f[^ 2 ( DEMOD_Lch )
    D4_IN   => FM_DETOUT,     -- <= FMDET   ̓f[^ 4 ( FM_DEMOD )
    I_IN    => ISIG2(19 downto 4), -- <= cic     ̓f[^ 3 ( I M )
    Q_IN    => QSIG2(19 downto 4), -- <= cic     ̓f[^ 3 ( Q M )
    
    L_OUT   => open,          -- I[fBI Lch A/D o
    R_OUT   => open,          -- I[fBI Rch A/D o
    ND      => open,          -- I[fBI A/D ϊo L
    
    SCK     => SCK,       -- 256fs =25MHz    =CLK/4
    BCK     => BCK,       -- 32fs  =3.125MHz =CLK/32
    LRCK    => LRCK,      -- fs    =97.656KHz =CLK/1024  L='0' R='1'
    I2SOUT  => I2SOUT,    -- I2S data to UDA1345 (MSB first)
    I2SIN   => UDA_DATAO, -- I2S data from UDA1345 (MSB first)
    
    L3MODE  => L3MODE,    -- MP2
    L3CLK   => L3CLK,     -- MP3  2MHzmax
    L3DATA  => L3DATA     -- MP4
  );
  
  UDA_SYSCLK  <= SCK;                        -- UDA1345 SYSCLK         P41
  UDA_L3MODE  <= L3MODE;                        -- UDA1345 MP2            P40
  UDA_L3CLK   <= L3CLK;                        -- UDA1345 MP3            P35
  UDA_L3DATA  <= L3DATA;                        -- UDA1345 MP4            P29
  UDA_BCK     <= BCK;                        -- UDA1345 BCK            P30
  UDA_WS      <= LRCK;                        -- UDA1345 WS             P32
  UDA_DATAI   <= I2SOUT;                        -- UDA1345 DATAI          P34
  
  
  
  ------------------------------------------------------------------------------------------
  --  MEMORY
  ------------------------------------------------------------------------------------------
  M7 : memcontrol
  port map (
    RESET   => RESET,
    CLK     => CLK100,
    MCE     => MCE(7),        -- Addrs=0x07xx
    MWE     => MWE,
    MADR    => MADR,
    MWDATA  => MWDATA,
    MRDATA  => MEM_MRDATA,
    
    MEMDATAIN0 => CIC_WDATA,  -- <= cic         
    MEMDATAIN1 => "00000000" & FM_MEMWDATA,   -- <= FMDET     
    MEMDATAOUT => open,
    MEMWE0    => CIC_WEN,     -- <= cic         
    MEMWE1    => FM_MEMWE,    -- <= FMDET     
    TRG0      => OSC_TRG,     -- <= oscilloscope     
    TRG1      => FM_TRG       -- <= FMDET     
  );
  
  
  ------------------------------------------------------------------------------------------
  --  FREQ_DET ( FM analyzer & Freq counter )
  ------------------------------------------------------------------------------------------
  M8: freqdet
  port map(
    RESET   => RESET,             -- 
    CLK     => CLK100,            -- 
    
    MCE     => MCE(8),            -- module select  Addrs=0x08xx
    MWE     => MWE,                                   -- 
    MADR    => MADR,              -- AhX
    MWDATA  => MWDATA,            -- ރf[^
    MRDATA  => FM_MRDATA,        -- ǂݏof[^
    
    CNT32   => CNT32,             -- JE^[l
    DSIGIN  => CN14(7 downto 0),  -- MfW^
    ASIGIN  => ADCDATA,           -- AiO( ADC1610 o )
    
    I_IN    => ISIG2(19 downto 2), -- cic  gϊ CIC ʂM
    Q_IN    => QSIG2(19 downto 2),
    ND      => CIC_WEN,            -- I_IN, Q_IN L
    
    DET_OUT => FM_DETOUT,         -- FMo
    MEMWDATA=> FM_MEMWDATA,    -- [ݗpf[^o
    MEMWE   => FM_MEMWE,       -- lݗL
    TRG     => FM_TRG          -- gK[
  );
  
  
  ------------------------------------------------------------------------------------------
  --  DEMOD
  ------------------------------------------------------------------------------------------
  M10 : demod
  port map (
    RESET   => RESET,
    CLK     => CLK100,
    MEME    => MEME,          -- IIR 0x7000-0x7FFF
    MCE     => MCE(10),        -- Module Chip Enable  Addrs=0x0Axx
    MWE     => MWE,
    MRE     => MRE,
    MADR    => MADR,          -- W[AhX
    MWDATA  => MWDATA,        -- 
    MRDATA  => DEMOD_MRDATA,  -- data bus output
    
    I_IN    => ISIG2(19 downto 0) & "0000000000000", -- <= cic     ̓f[^ 3 ( I M )
    Q_IN    => QSIG2(19 downto 0) & "0000000000000", -- <= cic     ̓f[^ 3 ( Q M )
    
    L_OUT   => DEMOD_L,  -- L Mo
    R_OUT   => DEMOD_R   -- R Mo
  );
  
  
  MEME <= '1' when(MADR(15 downto 12)="0111") else '0';  -- IIR 0x7000-0x7FFF
  
  
  ------------------------------------------------------------------------------------------
  --  oscilloscope
  ------------------------------------------------------------------------------------------
  M11 : oscilloscope
  port map (
    RESET   => RESET,
    CLK     => CLK100,
    MCE     => MCE(11),        -- Module Chip Enable  Addrs=0x0Bxx
    MWE     => MWE,
    MADR    => MADR,          -- W[AhX
    MWDATA  => MWDATA,        -- 
    
    I_IN    => ISIG2(19 downto 2), -- cic  gϊ CIC ʂM
    Q_IN    => QSIG2(19 downto 2),
    ND      => CIC_WEN,            -- I_IN, Q_IN L
    
    DSIGOUT => CN12(1),         -- g``ăfW^M  P79 CN12(8pin)
    TRG     => OSC_TRG          -- gK[
  );
  
  
  ------------------------------------------------------------------------------------------
  --  others
  ------------------------------------------------------------------------------------------
  RESET <= not RESET_X;
  
  
  ------------------------------------------------------------------------------------------
  --  DEBUG
  ------------------------------------------------------------------------------------------
  LED     <= CNT32(25);           -- P80
  CN12(0) <= DDS1(17);            -- dds1 `go  P78 CN12(7pin)
  
end RTL;

