----------------------------------------------------------------------------------
--  
--        cic.vhd        fV[VςbhbtB^[
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity cic is 
  port (
    RESET   : in  std_logic;
    IOCLK   : in  std_logic;                      -- io bus clock = 100MHz
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MADR    : in  std_logic;                      -- W[AhX
    MWDATA  : in  std_logic_vector( 7 downto 0 ); -- W[֏ރf[^
    
    CLK        : in  std_logic;
    DATA_I_IN  : in  std_logic_vector( 17 downto 0); -- h̓f[^
    DATA_Q_IN  : in  std_logic_vector( 17 downto 0); -- p̓f[^
    DATA_I_OUT : out std_logic_vector( 19 downto 0); -- ho̓f[^
    DATA_Q_OUT : out std_logic_vector( 19 downto 0); -- po̓f[^
    WEN        : out std_logic;                      -- o̓f[^݃^C~O
    DEBUG      : out std_logic_vector( 7 downto 0)
  );
end cic;


------------------------------------------------------------------------------
architecture RTL of cic is
  
  signal DATA_I_0_OUT: std_logic_vector( 19 downto 0); -- 
  signal DATA_Q_0_OUT: std_logic_vector( 19 downto 0); -- 
  signal WEN_0       : std_logic; -- 
  signal DRATE       : std_logic_vector( 3 downto 0); -- 
  
  component cic_3_4096
    port (
      CICR_RESET   : in  std_logic;
      CICR_CLK     : in  std_logic;
      CICR_REN     : in  std_logic;                      -- ̓f[^ǂݍ݃^C~O
      CICR_DATAIN  : in  std_logic_vector( 17 downto 0); -- ̓f[^
      CICR_WEN     : out std_logic;                      -- o̓f[^݃^C~O
      CICR_DATAOUT : out std_logic_vector( 19 downto 0); -- o̓f[^
      CICR_DRATE   : in  std_logic_vector( 3 downto 0 ); -- fV[VI 2..64
      CICR_TEST    : out std_logic                       -- for debug
    );
  end component;
  
  begin
    
    CIC_I_0 : cic_3_4096
      port map (
        CICR_RESET   => RESET,
        CICR_CLK     => CLK,
        CICR_REN     => '1',
        CICR_DATAIN  => DATA_I_IN,
        CICR_WEN     => WEN_0,
        CICR_DATAOUT => DATA_I_0_OUT,
        CICR_DRATE   => DRATE,
        CICR_TEST    => open
      );
    
    CIC_Q_0 : cic_3_4096
      port map (
        CICR_RESET   => RESET,
        CICR_CLK     => CLK,
        CICR_REN     => '1',
        CICR_DATAIN  => DATA_Q_IN,
        CICR_WEN     => open,
        CICR_DATAOUT => DATA_Q_0_OUT,
        CICR_DRATE   => DRATE,
        CICR_TEST    => open
      );
    
    DATA_I_OUT <= DATA_I_0_OUT;
    DATA_Q_OUT <= DATA_Q_0_OUT;
    WEN <= WEN_0;
    
    DEBUG <= WEN_0 & "000" & DRATE;
    
    ------------------------------------------------------------------
    --    fV[Vݒ
    ------------------------------------------------------------------
    process( RESET, IOCLK ) begin
      if ( RESET ='1') then
        DRATE <= (others => '0');
      elsif( rising_edge(IOCLK) ) then
        if( MCE='1' and MWE='1' ) then
          DRATE <= MWDATA( 3 downto 0 );
        end if;
      end if;
    end process;
    
    
  end RTL;
----------------------------- end of architecture ----------------------------

