----------------------------------------------------------------------------------
--  
--        cic_3_4096.vhd        fV[VςbhbtB^[( N=3, R=1..4096 )
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
-- Number of Slices:                      364  out of   2448    14%  
-- Number of Slice Flip Flops:            569  out of   4896    11%  
-- Number of 4 input LUTs:                499  out of   4896    10%  
--
--   Minimum period: 5.707ns (Maximum Frequency: 175.225MHz)
--   Minimum input arrival time before clock: 4.367ns
--   Maximum output required time after clock: 8.236ns
--   Maximum combinational path delay: 9.575ns

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity cic_3_4096 is 
  generic (
    DIN_SIZE  : INTEGER := 18;  -- ̓rbg
    DATA_SIZE : INTEGER := 54;  -- f[^rbgiCICiƍőfV[VŕKv
                                -- rbg܂j = DIN_SIZE + N * log2( RMAX )
    DOUT_SIZE : INTEGER := 20;  -- o̓rbg
    N         : INTEGER := 3;   -- CIC i
    RMAX      : INTEGER := 4096 -- őfV[V
  );
  port (
    CICR_RESET   : in  std_logic;
    CICR_CLK     : in  std_logic;
    CICR_REN     : in  std_logic;                               -- ̓f[^ǂݍ݃^C~O
    CICR_DATAIN  : in  std_logic_vector( DIN_SIZE-1 downto 0);  -- ̓f[^
    CICR_WEN     : out std_logic;                               -- o̓f[^݃^C~O
    CICR_DATAOUT : out std_logic_vector( DOUT_SIZE-1 downto 0); -- o̓f[^
    CICR_DRATE   : in  std_logic_vector( 3 downto 0 );          -- fV[VI 2..64
    CICR_TEST    : out std_logic                                -- for debug
  );
end cic_3_4096;


------------------------------------------------------------------------------
architecture RTL of cic_3_4096 is
  
  type darray is array (N downto 0) of std_logic_vector(DATA_SIZE-1 downto 0);
  signal D     :  darray;        -- Integrater 
  signal DR    :  darray;        -- Comb Filter 
  signal DRM1  :  darray;        -- Comb Filter p̒x
  
  signal R      : integer range 0 to RMAX-1; -- fV[V
  signal RCOUNT : integer range 0 to RMAX-1; -- fV[ṼJE^[
  signal WEN    : std_logic;                 -- o̓f[^L
  
  signal DATAOUT: std_logic_vector(20 downto 0);
  
  begin
    
    CICR_WEN <= CICR_REN when( CICR_DRATE = "0000" ) else   -- fV[VȂ
                WEN;
    
    DATAOUT <= CICR_DATAIN(DIN_SIZE-1 downto 0) & "000" when( CICR_DRATE = "0000" ) else -- fV[VȂ
               DR(N)( DATA_SIZE-1-N*11 downto DATA_SIZE-N*11-1-DOUT_SIZE )  when( CICR_DRATE = "0001" ) else
               DR(N)( DATA_SIZE-1-N*10 downto DATA_SIZE-N*10-1-DOUT_SIZE )  when( CICR_DRATE = "0010" ) else
               DR(N)( DATA_SIZE-1-N*9  downto DATA_SIZE-N*9 -1-DOUT_SIZE )  when( CICR_DRATE = "0011" ) else
               DR(N)( DATA_SIZE-1-N*8  downto DATA_SIZE-N*8 -1-DOUT_SIZE )  when( CICR_DRATE = "0100" ) else
               DR(N)( DATA_SIZE-1-N*7  downto DATA_SIZE-N*7 -1-DOUT_SIZE )  when( CICR_DRATE = "0101" ) else
               DR(N)( DATA_SIZE-1-N*6  downto DATA_SIZE-N*6 -1-DOUT_SIZE )  when( CICR_DRATE = "0110" ) else
               DR(N)( DATA_SIZE-1-N*5  downto DATA_SIZE-N*5 -1-DOUT_SIZE )  when( CICR_DRATE = "0111" ) else
               DR(N)( DATA_SIZE-1-N*4  downto DATA_SIZE-N*4 -1-DOUT_SIZE )  when( CICR_DRATE = "1000" ) else
               DR(N)( DATA_SIZE-1-N*3  downto DATA_SIZE-N*3 -1-DOUT_SIZE )  when( CICR_DRATE = "1001" ) else
               DR(N)( DATA_SIZE-1-N*2  downto DATA_SIZE-N*2 -1-DOUT_SIZE )  when( CICR_DRATE = "1010" ) else
               DR(N)( DATA_SIZE-1-N*1  downto DATA_SIZE-N*1 -1-DOUT_SIZE )  when( CICR_DRATE = "1011" ) else
               DR(N)( DATA_SIZE-1      downto DATA_SIZE     -1-DOUT_SIZE );
    
    ------------------------------------------------------------------
    -- bhbo͐MQPrbgڂłÔPĂQOrbgɂ
    ------------------------------------------------------------------
    process( CICR_CLK ) begin
      if ( rising_edge( CICR_CLK ) ) then
        CICR_DATAOUT <= DATAOUT(20 downto 1) + ("0000000000000000000" & DATAOUT(0) );
      end if;
    end process;
    
    
    
    R <= 1    when( CICR_DRATE = "0001" ) else   -- decimation_rate-1
         3    when( CICR_DRATE = "0010" ) else
         7    when( CICR_DRATE = "0011" ) else
         15   when( CICR_DRATE = "0100" ) else
         31   when( CICR_DRATE = "0101" ) else
         63   when( CICR_DRATE = "0110" ) else
         127  when( CICR_DRATE = "0111" ) else
         255  when( CICR_DRATE = "1000" ) else
         511  when( CICR_DRATE = "1001" ) else
         1023 when( CICR_DRATE = "1010" ) else
         2047 when( CICR_DRATE = "1011" ) else
         4095;
    
    
    ------------------------------------------------------------------
    -- Integrater   ͐M signed 
    ------------------------------------------------------------------
    process( CICR_RESET, CICR_CLK ) begin
      if (CICR_RESET = '1') then 
        for i in 0 to N loop
          D(i) <= (others => '0');
        end loop;
      elsif (rising_edge (CICR_CLK)) then
        if( CICR_REN = '1' ) then
          D(0)(DATA_SIZE-1 downto DIN_SIZE) <= (others => CICR_DATAIN(DIN_SIZE-1)); -- g
          D(0)(DIN_SIZE-1 downto 0) <= CICR_DATAIN;
          for i in 1 to N loop          -- integration loop
            D(i) <= D(i-1) + D(i);
          end loop;
        end if;
      end if;
    end PROCESS;
    
    
    ------------------------------------------------------------------
    --  Comb Filter
    ------------------------------------------------------------------
    process( CICR_RESET, CICR_CLK ) begin
      if (CICR_RESET = '1') then 
        DR(0) <= (others => '0');
        for i in 1 to N loop
          DRM1(i) <= (others => '0');
          DR(i) <= (others => '0');
        end loop;
      elsif (rising_edge (CICR_CLK)) then
        if (WEN = '1') then             -- decimation
          DR(0) <= D(N); 
          for i in 1 to N loop
            DRM1(i) <= DR(i-1);
            DR(i) <= DR(i-1) - DRM1(i);
          end loop;
        end if;
      end if;
    end PROCESS;
    
    
    ------------------------------------------------------------------
    --  Decimation rate counter
    ------------------------------------------------------------------
    process( CICR_RESET, CICR_CLK ) begin
      if( CICR_RESET = '1' ) then
        RCOUNT <= 0;
      elsif( rising_edge( CICR_CLK ) ) then
        if( CICR_REN = '1' ) then
          if( RCOUNT = 0 ) then
            WEN <= '1';
            RCOUNT <= R;
          else
            WEN <= '0';
            RCOUNT <= RCOUNT - 1;
          end if;
        else
          WEN <= '0';
        end if;
      end if;
    end process;
    
    
  end RTL;
----------------------------- end of architecture ----------------------------

