----------------------------------------------------------------------------------
--  
--        dds.vhd        dds0, dds1, dds2 Rg[
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
-- Number of Slices:                      679  out of   2448    27%  
-- Number of Slice Flip Flops:            665  out of   4896    13%  
-- Number of 4 input LUTs:               1143  out of   4896    23%  
-- 
--   Minimum period: 10.054ns (Maximum Frequency: 99.466MHz)
--   Minimum input arrival time before clock: 4.942ns
--   Maximum output required time after clock: 7.015ns
--   Maximum combinational path delay: No path found
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

Library UNISIM;
use UNISIM.vcomponents.all;

------------------------------------------------------------------------------
entity dds is
  port (
    RESET   : in  std_logic;
    IOCLK   : in  std_logic;                      -- io bus clock
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MADR    : in  std_logic_vector(15 downto 0 ); -- W[AhX
    MWDATA  : in  std_logic_vector( 7 downto 0 ); -- W[֏ރf[^
    
    DDSCLK  : in  std_logic;
    
    AMP     : out std_logic_vector(17 downto 0);  -- `lϒEUiۂ̏ADC9707ubNj
    
    COS0    : out std_logic_vector(17 downto 0);  -- ccrO@o
    SIN0    : out std_logic_vector(17 downto 0);
    
    SIG1    : out std_logic_vector(17 downto 0);  -- ccrP@o
    
    SIG2    : out std_logic_vector(15 downto 0);  -- ccrQ@o
    
    SIG3    : out std_logic_vector(15 downto 0)   -- ccrR@o
  );
end dds;

------------------------------------------------------------------------------
architecture RTL of dds is
  
  signal RESET_PHASE0 : STD_LOGIC;
  signal RESET_PHASE3 : STD_LOGIC;
  signal DDSOUT2: STD_LOGIC_VECTOR (15 downto 0);
  signal DDSOUT3: STD_LOGIC_VECTOR (15 downto 0);
  signal AMLEVEL: STD_LOGIC_VECTOR (31 downto 0);
  signal FMLEVEL: STD_LOGIC_VECTOR (31 downto 0);
  signal FREQ0  : STD_LOGIC_VECTOR (31 downto 0);
  signal FREQ1  : STD_LOGIC_VECTOR (31 downto 0);
  signal FREQ2  : STD_LOGIC_VECTOR (31 downto 0);
  signal FREQ3  : STD_LOGIC_VECTOR (31 downto 0);
  signal PHASE3_INIT : std_logic_vector(15 downto 0);    -- ʑQ̏l
  signal DSB    : STD_LOGIC;
  signal WAVE2  : STD_LOGIC_VECTOR (1 downto 0);
  signal WAVE3  : STD_LOGIC_VECTOR (1 downto 0);
  signal FM1    : STD_LOGIC_VECTOR (3 downto 0);
  signal AM1    : STD_LOGIC_VECTOR (3 downto 0);
  signal AMP1   : STD_LOGIC_VECTOR (15 downto 0);
  signal FREQ1MOD : STD_LOGIC_VECTOR (31 downto 0);
  signal AMP1MOD  : STD_LOGIC_VECTOR (17 downto 0);
  
  component dds0
  port (
    DDSCLK      : in  std_logic;
    FREQ        : in  std_logic_vector(31 downto 0);    -- g
    RESET_PHASE : in  std_logic;                        -- ʑZbg
    COS         : out std_logic_vector(17 downto 0);    -- RTCo
    SIN         : out std_logic_vector(17 downto 0)     -- TCo
  );
  end component;
  
  
  component dds1
  port (
    DDSCLK  : in  std_logic;
    FREQ    : in  std_logic_vector(31 downto 0);    -- g
    SIG     : out std_logic_vector(17 downto 0)     -- Mo
  );
  end component;
  
  component dds3
  port (
    RESET   : in  std_logic;
    DDSCLK  : in  std_logic;
    FREQ1   : in  std_logic_vector(23 downto 0);    -- gP
    FREQ2   : in  std_logic_vector(23 downto 0);    -- gQ
    PHASE2_INIT  : in  std_logic_vector(15 downto 0);    -- ʑQ̏l
    WAVE1   : in  std_logic_vector(1 downto 0);     -- g`ނP
    WAVE2   : in  std_logic_vector(1 downto 0);     -- g`ނQ
    SIG1    : out std_logic_vector(15 downto 0);     -- Mo͂P
    SIG2    : out std_logic_vector(15 downto 0)     -- Mo͂Q
  );
  end component;
  
  component shiftra16
  port (
    X   : in  std_logic_vector( 15 downto 0 ); -- 
    Y   : out std_logic_vector( 15 downto 0 ); -- o̓f[^
    N   : in  std_logic_vector( 3 downto 0 )   -- Vtg
  );
  end component;
  
  
  component shiftra32
  port (
    X   : in  std_logic_vector( 31 downto 0 ); -- 
    Y   : out std_logic_vector( 31 downto 0 ); -- o̓f[^
    N   : in  std_logic_vector(  4 downto 0 )  -- Vtg
  );
  end component;
  
  
  begin
    
    u0 : dds0
    port map (
      DDSCLK  => DDSCLK,
      FREQ    => FREQ0,         -- g
      RESET_PHASE => RESET_PHASE0, -- ʑZbg
      COS     => COS0,          -- RTCo
      SIN     => SIN0           -- TCo
    );
    
    u1 : dds1
    port map (
      DDSCLK  => DDSCLK,
      FREQ    => FREQ1MOD,    -- g
      SIG     => SIG1         -- Mo
    );
    
    
    u2 : dds3
    port map (
      RESET   => RESET_PHASE3,          -- ʑZbg
      DDSCLK  => DDSCLK,
      FREQ1   => FREQ2(23 downto 0),    -- gP
      FREQ2   => FREQ3(23 downto 0),    -- gQ
      PHASE2_INIT => PHASE3_INIT,    -- ʑQ̏l
      WAVE1   => WAVE2,     -- g`ނP
      WAVE2   => WAVE3,     -- g`ނQ
      SIG1    => DDSOUT2,     -- Mo͂P
      SIG2    => DDSOUT3     -- Mo͂Q
    );
    
    
    u4 : shiftra32              -- AM ϒ
    port map (
      X  => DDSOUT2 & "0000000000000000",          -- 
      Y  => AMLEVEL,          -- o
      N  => "0" & AM1               -- Vtg
    );
    
    
    u5 : shiftra32              -- FM ϒ
    port map (
      X  => DDSOUT3 & "0000000000000000",          -- 
      Y  => FMLEVEL,          -- o
      N  => "0" & FM1               -- Vtg
    );
    
    AMP  <= AMP1MOD;          -- `lϒEU

    
    SIG2 <= DDSOUT2;
    SIG3 <= DDSOUT3;
    
    
    ------------------------------------------------------------------
    --    eccr̎gAg`AUA`l^elϒ@ݒ
    ------------------------------------------------------------------
    process( RESET, IOCLK ) begin
      if ( RESET ='1') then
        RESET_PHASE0 <= '1';
        RESET_PHASE3 <= '1';
        FREQ0 <= (others => '0');
        FREQ1 <= (others => '0');
        FREQ2 <= (others => '0');
        FREQ3 <= (others => '0');
        PHASE3_INIT <= (others => '0');
        WAVE2 <= (others => '0');
        WAVE3 <= (others => '0');
        AM1   <= (others => '0');
        FM1   <= (others => '0');
        AMP1  <= (others => '0');
      elsif( rising_edge(IOCLK) ) then
        if( MWE='1' and MCE='1' ) then
          case MADR( 4 downto 0 ) is
            when( "00000" ) => FREQ0( 7 downto  0) <= MWDATA;    -- gݒ ccrO
            when( "00001" ) => FREQ0(15 downto  8) <= MWDATA;    --
            when( "00010" ) => FREQ0(23 downto 16) <= MWDATA;    --
            when( "00011" ) => FREQ0(31 downto 24) <= MWDATA;    --
                               RESET_PHASE0 <= '1';              -- ʑZbg
            
            when( "01000" ) => FREQ1( 7 downto  0) <= MWDATA;    -- gݒ ccrP
            when( "01001" ) => FREQ1(15 downto  8) <= MWDATA;    --
            when( "01010" ) => FREQ1(23 downto 16) <= MWDATA;    --
            when( "01011" ) => FREQ1(31 downto 24) <= MWDATA;    --
            when( "01100" ) => DSB   <= MWDATA(2);               -- DSB/AM
            when( "01101" ) => FM1   <= MWDATA(7 downto 4);      -- FM ϒw
                               AM1   <= MWDATA(3 downto 0);      -- AM ϒx
            when( "01110" ) => AMP1(7 downto 0)  <= MWDATA;      -- U
            when( "01111" ) => AMP1(15 downto 8) <= MWDATA;     -- 
            
            when( "10000" ) => FREQ2( 7 downto  0) <= MWDATA;    -- gݒ ccrQ
            when( "10001" ) => FREQ2(15 downto  8) <= MWDATA;    --
            when( "10010" ) => FREQ2(23 downto 16) <= MWDATA;    --
            when( "10100" ) => WAVE2 <= MWDATA(1 downto 0);      -- g`
            
            when( "11000" ) => FREQ3( 7 downto  0) <= MWDATA;    -- gݒ ccrR
            when( "11001" ) => FREQ3(15 downto  8) <= MWDATA;    --
            when( "11010" ) => FREQ3(23 downto 16) <= MWDATA;    --
            when( "11100" ) => WAVE3 <= MWDATA(1 downto 0);      -- g`
            when( "11101" ) => PHASE3_INIT( 7 downto  0) <= MWDATA;    -- ʑ ccrR
            when( "11110" ) => PHASE3_INIT(15 downto  8) <= MWDATA;    --
            when  others => 
          end case;
          
          if( MADR( 4 downto 3 ) ="11" ) then
            RESET_PHASE3 <= '1';
          end if;
          
        else
          RESET_PHASE0 <= '0';
          RESET_PHASE3 <= '0';
        end if;
      end if;
    end process;
    
    
    ------------------------------------------------------------------
    --    ccrP̂`lϒAo̓x
    ------------------------------------------------------------------
    process( DDSCLK ) begin
      if( rising_edge(DDSCLK) ) then
        if( DSB = '1' ) then
--          AMP1MOD <= AMLEVEL&"00";          -- DSB
          AMP1MOD <= AMLEVEL(31 downto 14);          -- DSB
        elsif( AM1 = "0000" ) then
          AMP1MOD <= "0" & AMP1 & "0";      -- AMϒȂƂ͏o̓xg
        else
--          AMP1MOD <= "010000000000000000" + (AMLEVEL & "00");  -- 0.5+AM
          AMP1MOD <= "010000000000000000" + AMLEVEL(31 downto 14);  -- 0.5+AM
        end if;
      end if;
    end process;
    
    
    ------------------------------------------------------------------
    --    ccrP̂elϒ
    ------------------------------------------------------------------
    process( DDSCLK ) begin
      if( rising_edge(DDSCLK) ) then
        if( FM1 = "0000" ) then
          FREQ1MOD <= FREQ1;                -- ϒ
        else
--          FREQ1MOD <= FREQ1 + (FMLEVEL&"0000000000000000");      -- 
          FREQ1MOD <= FREQ1 + FMLEVEL;      -- 
        end if;
      end if;
    end process;
    
    
  end RTL;
----------------------------- end of architecture ----------------------------
