----------------------------------------------------------------------------------
--  
--        demod.vhd        Demodulator
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--20100204 SSBqxgϊɂ
-- Number of Slices:                      495  out of   2448    20%  
-- Number of Slice Flip Flops:            407  out of   4896     8%  
-- Number of 4 input LUTs:                936  out of   4896    19%  
-- Number of IOs:                         140
-- Number of bonded IOBs:                 135  out of     66   204% (*) 
-- Number of BRAMs:                         2  out of     12    16%  
-- Number of MULT18X18SIOs:                 2  out of     12    16%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 10.012ns (Maximum Frequency: 99.880MHz)
--   Minimum input arrival time before clock: 11.704ns
--   Maximum output required time after clock: 9.667ns
--   Maximum combinational path delay: 10.130ns
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity demod is 
  port (
    RESET   : in  std_logic;
    CLK     : in  std_logic;                      -- 100MHz
    MEME    : in  std_logic;                      -- Memory Enable
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MRE     : in  std_logic;                      -- Module Read Enable
    MADR    : in  std_logic_vector(15 downto 0);  -- W[AhX
    MWDATA  : in  std_logic_vector(7 downto 0);   -- data bus input
    MRDATA  : out std_logic_vector(7 downto 0);   -- data bus output
    
    I_IN    : in  std_logic_vector(32 downto 0);  -- I M
    Q_IN    : in  std_logic_vector(32 downto 0);  -- Q M
    
    L_OUT   : out std_logic_vector(17 downto 0);  -- L Mo
    R_OUT   : out std_logic_vector(17 downto 0)   -- R Mo
    
  );
end demod;


------------------------------------------------------------------------------
architecture RTL of demod is
  
  signal CNT     : std_logic_vector(10 downto 0);  -- 
  signal AM_OUT  : std_logic_vector(15 downto 0); -- 
  signal SSB_OUT : std_logic_vector(15 downto 0); -- 
  
  signal I_GAIN  : std_logic_vector(17 downto 0); -- 
  signal Q_GAIN  : std_logic_vector(17 downto 0); -- 
  signal I_SAT   : std_logic_vector(15 downto 0); -- 
  signal Q_SAT   : std_logic_vector(15 downto 0); -- 
  signal I_G1    : std_logic_vector(14 downto 0); -- 
  signal Q_G1    : std_logic_vector(14 downto 0); -- 
  signal I_1     : std_logic_vector(17 downto 0); -- 
  signal Q_1     : std_logic_vector(17 downto 0); -- 
  signal DEM_0   : std_logic_vector(17 downto 0); -- 
  signal DEM_1   : std_logic_vector(17 downto 0); -- 
  
  signal I_LEVEL : std_logic_vector(3 downto 0); -- 
  signal Q_LEVEL : std_logic_vector(3 downto 0); -- 
  signal I_LEVEL_MAX : std_logic_vector(3 downto 0); -- 
  signal Q_LEVEL_MAX : std_logic_vector(3 downto 0); -- 
  signal GAIN    : std_logic_vector(3 downto 0); -- 
  
  signal SEL     : std_logic_vector(1 downto 0); -- 
  signal SSBSEL  : std_logic;                    -- SSB[hI  0:LSB 1:USB
  
  signal LEVELDATAOUT : std_logic_vector(7 downto 0); -- 
  signal IIRDATAOUT   : std_logic_vector(7 downto 0); -- 
  
  component iir 
  port (
    RESET   : in  STD_LOGIC;                        -- 
    CLK     : in  STD_LOGIC;                        -- 100MHz
    NDIN    : in  STD_LOGIC;                        -- ͓M 39KHz
    DIN_0   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[́@O
    DIN_1   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[́@P
    DIN_2   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[́@Q
    DIN_3   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[́@R
    DOUT_0  : out STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[ó@O
    DOUT_1  : out STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[ó@P
    DOUT_2  : out STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[ó@Q
    DOUT_3  : out STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[ó@R
    
    MEME    : in  STD_LOGIC;                        -- 
    MWE     : in  STD_LOGIC;                        -- 
    MADR    : in  STD_LOGIC_VECTOR ( 15 downto 0);  -- W[AhX
    MWDATA  : in  STD_LOGIC_VECTOR (  7 downto 0);  -- W[f[^
    MRDATA  : out STD_LOGIC_VECTOR (  7 downto 0)   -- W[f[^o
  );
  end component;
  
  component am_det   -- AM 
  port (
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- New Data
    I_IN    : in  std_logic_vector( 15 downto 0 ); -- I M
    Q_IN    : in  std_logic_vector( 15 downto 0 ); -- Q M
    SIG_OUT : out std_logic_vector( 15 downto 0 ); -- o̓f[^
    OD      : out std_logic                        -- o̓f[^Cl[u
  );
  end component;
  
  component ssb  -- SSB 
  port (
    RESET   : in  std_logic;                       -- 
    CLK     : in  std_logic;                       -- 100MHz
    ND      : in  std_logic;                       -- New Data
    I_IN    : in  std_logic_vector( 17 downto 0 ); -- I M
    Q_IN    : in  std_logic_vector( 17 downto 0 ); -- Q M
    SSB_OUT : out std_logic_vector( 15 downto 0 ); -- SSBo̓f[^
    SSBSEL  : in  std_logic                        -- USBI  0:LSB 1:USB
  );
  end component;
  
  
begin
  
  U0: iir
  port map (
    RESET    => RESET,                        -- 
    CLK      => CLK,                          -- 100MHz
    NDIN     => '0',                          -- ͓M
    DIN_0    => DEM_0,   -- tB^[́@O
    DIN_1    => DEM_0,   -- tB^[́@P
    DIN_2    => DEM_0,   -- tB^[́@Q
    DIN_3    => DEM_0,   -- tB^[́@R
    DOUT_0   => DEM_1,   -- tB^[ó@O
    DOUT_1   => open,    -- tB^[ó@P
    DOUT_2   => open,     -- tB^[ó@Q
    DOUT_3   => open,     -- tB^[ó@R
    MEME     => MEME,                       -- 0x7000 - 0x7FFF
    MWE      => MWE,                        -- 
    MADR     => MADR,  -- W[AhX
    MWDATA   => MWDATA,  -- f[^
    MRDATA  => IIRDATAOUT   -- f[^o
  );
  
  u1: am_det
  port map (
    CLK       => CLK,
    I_IN      => I_GAIN(17 downto 2),
    Q_IN      => Q_GAIN(17 downto 2),
    ND        => CNT(10),        
    SIG_OUT   => AM_OUT
  );
  
  u2: ssb
  port map (
    RESET   => RESET,         -- 
    CLK     => CLK,           -- 100MHz
    ND      => CNT(10),       -- New Data
    I_IN    => I_GAIN,        -- I M
    Q_IN    => Q_GAIN,        -- Q M
    SSB_OUT => SSB_OUT,       -- SSBo̓f[^
    SSBSEL  => SEL(0)         -- USBI  0:LSB 1:USB
  );
  
  I_GAIN <= I_IN(32 downto 15) when( GAIN="0000" ) else
            I_IN(32) & I_IN(30 downto 14) when( GAIN="0001" ) else
            I_IN(32) & I_IN(29 downto 13) when( GAIN="0010" ) else
            I_IN(32) & I_IN(28 downto 12) when( GAIN="0011" ) else
            I_IN(32) & I_IN(27 downto 11) when( GAIN="0100" ) else
            I_IN(32) & I_IN(26 downto 10) when( GAIN="0101" ) else
            I_IN(32) & I_IN(25 downto  9) when( GAIN="0110" ) else
            I_IN(32) & I_IN(24 downto  8) when( GAIN="0111" ) else
            I_IN(32) & I_IN(23 downto  7) when( GAIN="1000" ) else 
            I_IN(32) & I_IN(22 downto  6) when( GAIN="1001" ) else
            I_IN(32) & I_IN(21 downto  5) when( GAIN="1010" ) else
            I_IN(32) & I_IN(20 downto  4) when( GAIN="1011" ) else
            I_IN(32) & I_IN(19 downto  3) when( GAIN="1100" ) else
            I_IN(32) & I_IN(18 downto  2) when( GAIN="1101" ) else
            I_IN(32) & I_IN(17 downto  1) when( GAIN="1110" ) else 
            I_IN(32) & I_IN(16 downto  0);
  
  
  Q_GAIN <= Q_IN(32 downto 15) when( GAIN="0000" ) else
            Q_IN(32) & Q_IN(30 downto 14) when( GAIN="0001" ) else
            Q_IN(32) & Q_IN(29 downto 13) when( GAIN="0010" ) else
            Q_IN(32) & Q_IN(28 downto 12) when( GAIN="0011" ) else
            Q_IN(32) & Q_IN(27 downto 11) when( GAIN="0100" ) else
            Q_IN(32) & Q_IN(26 downto 10) when( GAIN="0101" ) else
            Q_IN(32) & Q_IN(25 downto  9) when( GAIN="0110" ) else
            Q_IN(32) & Q_IN(24 downto  8) when( GAIN="0111" ) else
            Q_IN(32) & Q_IN(23 downto  7) when( GAIN="1000" ) else 
            Q_IN(32) & Q_IN(22 downto  6) when( GAIN="1001" ) else
            Q_IN(32) & Q_IN(21 downto  5) when( GAIN="1010" ) else
            Q_IN(32) & Q_IN(20 downto  4) when( GAIN="1011" ) else
            Q_IN(32) & Q_IN(19 downto  3) when( GAIN="1100" ) else
            Q_IN(32) & Q_IN(18 downto  2) when( GAIN="1101" ) else
            Q_IN(32) & Q_IN(17 downto  1) when( GAIN="1110" ) else 
            Q_IN(32) & Q_IN(16 downto  0);
  
  
  I_LEVEL <= "1111" when( I_IN(32 downto 31)="01" or I_IN(32 downto 31)="10" ) else  -- >65536
             "1110" when( I_IN(31 downto 30)="01" or I_IN(31 downto 30)="10" ) else  -- >32768
             "1101" when( I_IN(30 downto 29)="01" or I_IN(30 downto 29)="10" ) else  -- >16384
             "1100" when( I_IN(29 downto 28)="01" or I_IN(29 downto 28)="10" ) else  -- >8192
             "1011" when( I_IN(28 downto 27)="01" or I_IN(28 downto 27)="10" ) else  -- >4096
             "1010" when( I_IN(27 downto 26)="01" or I_IN(27 downto 26)="10" ) else  -- >2048
             "1001" when( I_IN(26 downto 25)="01" or I_IN(26 downto 25)="10" ) else  -- >1024
             "1000" when( I_IN(25 downto 24)="01" or I_IN(25 downto 24)="10" ) else  -- >512
             "0111" when( I_IN(24 downto 23)="01" or I_IN(24 downto 23)="10" ) else  -- >256
             "0110" when( I_IN(23 downto 22)="01" or I_IN(23 downto 22)="10" ) else  -- >128
             "0101" when( I_IN(22 downto 21)="01" or I_IN(22 downto 21)="10" ) else  -- >64
             "0100" when( I_IN(21 downto 20)="01" or I_IN(21 downto 20)="10" ) else  -- >32
             "0011" when( I_IN(20 downto 19)="01" or I_IN(20 downto 19)="10" ) else  -- >16
             "0010" when( I_IN(19 downto 18)="01" or I_IN(19 downto 18)="10" ) else  -- >8
             "0001" when( I_IN(18 downto 17)="01" or I_IN(18 downto 17)="10" ) else  -- >4
             "0000" ;
  
  
  Q_LEVEL <= "1111" when( Q_IN(32 downto 31)="01" or Q_IN(32 downto 31)="10" ) else  -- >65536
             "1110" when( Q_IN(31 downto 30)="01" or Q_IN(31 downto 30)="10" ) else  -- >32768
             "1101" when( Q_IN(30 downto 29)="01" or Q_IN(30 downto 29)="10" ) else  -- >16384
             "1100" when( Q_IN(29 downto 28)="01" or Q_IN(29 downto 28)="10" ) else  -- >8192
             "1011" when( Q_IN(28 downto 27)="01" or Q_IN(28 downto 27)="10" ) else  -- >4096
             "1010" when( Q_IN(27 downto 26)="01" or Q_IN(27 downto 26)="10" ) else  -- >2048
             "1001" when( Q_IN(26 downto 25)="01" or Q_IN(26 downto 25)="10" ) else  -- >1024
             "1000" when( Q_IN(25 downto 24)="01" or Q_IN(25 downto 24)="10" ) else  -- >512
             "0111" when( Q_IN(24 downto 23)="01" or Q_IN(24 downto 23)="10" ) else  -- >256
             "0110" when( Q_IN(23 downto 22)="01" or Q_IN(23 downto 22)="10" ) else  -- >128
             "0101" when( Q_IN(22 downto 21)="01" or Q_IN(22 downto 21)="10" ) else  -- >64
             "0100" when( Q_IN(21 downto 20)="01" or Q_IN(21 downto 20)="10" ) else  -- >32
             "0011" when( Q_IN(20 downto 19)="01" or Q_IN(20 downto 19)="10" ) else  -- >16
             "0010" when( Q_IN(19 downto 18)="01" or Q_IN(19 downto 18)="10" ) else  -- >8
             "0001" when( Q_IN(18 downto 17)="01" or Q_IN(18 downto 17)="10" ) else  -- >4
             "0000" ;
  
  
  DEM_0 <= SSB_OUT & "00" when( SEL(1)='0' ) else
           AM_OUT & "00";
  
  L_OUT  <= Q_GAIN when( SEL="11" ) else
            DEM_0;
  
  R_OUT  <= I_GAIN when( SEL="11" ) else
            DEM_0;
  
  MRDATA <= LEVELDATAOUT or IIRDATAOUT;
  
  
  ------------------------------------------------------------------
  --  JE^[
  ------------------------------------------------------------------
  process( CLK ) begin
    if (rising_edge (CLK)) then
      CNT <= CNT+1;
    end if;
  end PROCESS;
  
  
  ------------------------------------------------------------------
  --  ݒ
  ------------------------------------------------------------------
  LEVELDATAOUT <= Q_LEVEL_MAX&I_LEVEL_MAX when( MCE='1' ) else "00000000";
  
  process( RESET, CLK ) begin
    if ( RESET ='1') then
      SEL <= "10";--(others => '0');        -- 
    elsif( rising_edge(CLK) ) then
      if( MWE='1' and MCE='1' ) then
        if( MADR(0)='0' ) then
          GAIN  <= MWDATA(7 downto 4);    -- QC
          SEL   <= MWDATA(1 downto 0);    -- MI
          I_LEVEL_MAX <= (others => '0');       -- xZbg
          Q_LEVEL_MAX <= (others => '0');       -- xZbg
        end if;
      else
        if( I_LEVEL_MAX < I_LEVEL ) then
          I_LEVEL_MAX <= I_LEVEL;               -- ő僌xێ
        end if;
        if( Q_LEVEL_MAX < Q_LEVEL ) then
          Q_LEVEL_MAX <= Q_LEVEL;               -- ő僌xێ
        end if;
      end if;
    end if;
  end process;
  
  
end RTL;



----------------------------- end of architecture ----------------------------

