----------------------------------------------------------------------------------
--  
--        fconv.vhd        gϊ
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--
-- Number of Slices:                       18  out of   2448     0%  
-- Number of Slice Flip Flops:             36  out of   4896     0%  
-- Number of 4 input LUTs:                 34  out of   4896     0%  
-- Number of IOs:                          86
-- Number of bonded IOBs:                  85  out of     66   128% (*) 
-- Number of MULT18X18SIOs:                 2  out of     12    16%  
-- Number of GCLKs:                         1  out of     24     4%  


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
--use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.STD_LOGIC_SIGNED.all;

library UNISIM;
use UNISIM.VComponents.all;

entity fconv is
  port (
    RESET   : in  STD_LOGIC;
    CLK     : in  STD_LOGIC;
    SIGIN   : in  STD_LOGIC_VECTOR (15 downto 0);   -- ADRo[^[̓́@2̕␔\
    ILOIN   : in  STD_LOGIC_VECTOR (17 downto 0);   -- LO
    QLOIN   : in  STD_LOGIC_VECTOR (17 downto 0);
    IOUT    : out STD_LOGIC_VECTOR (17 downto 0);   -- o
    QOUT    : out STD_LOGIC_VECTOR (17 downto 0)
  );
end fconv;

architecture RTL of fconv is
  
  signal A    : std_logic_VECTOR(17 downto 0);
  signal P0   : std_logic_VECTOR(35 downto 0);
  signal P1   : std_logic_VECTOR(35 downto 0);
  signal P0_D : std_logic_VECTOR(18 downto 0);
  signal P1_D : std_logic_VECTOR(18 downto 0);
  
  
  begin
    
    U0 : MULT18X18S
    port map (
      P => P0,      -- 36-bit multiplier output
      A => A,       -- 18-bit multiplier input
      B => ILOIN,   -- 18-bit multiplier input
      C => CLK,     -- Clock input
      CE => '1',    -- Clock enable input  
      R => '0'      -- Synchronous reset input
    );  
    
    
    U1 : MULT18X18S
    port map (
      P => P1,      -- 36-bit multiplier output
      A => A,       -- 18-bit multiplier input
      B => QLOIN,   -- 18-bit multiplier input
      C => CLK,     -- Clock input
      CE => '1',    -- Clock enable input  
      R => '0'      -- Synchronous reset input
    );  
    
    
    A    <= SIGIN & "00";
    
    
  ------------------------------------------------------------------
  --    o͂ÔP
  ------------------------------------------------------------------
  process (CLK) begin
    if( rising_edge( CLK ) ) then
      P0_D <= P0(34 downto 16);
      P1_D <= P1(34 downto 16);
      IOUT <= P0_D(18 downto 1) + ("00000000000000000"&P0_D(0));
      QOUT <= P1_D(18 downto 1) + ("00000000000000000"&P1_D(0));
    end if;
  end process;

end RTL;

