----------------------------------------------------------------------------------
--  
--        freqdet.vhd        go( fm_det, freq_counter )
--  
--        (c)2011/07/16  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--
----------------------------------------------------------------------------------
--  
-- WRITE
--    0x00   7 6 5 4 3 2 1 0
--                         +-- START/STOP  0 ƎgJE^~A1 ƎgJE^Jn@
--  
--  
--    0x01   7 6 5 4 3 2 1 0
--             | | | | +-+-+-- MESBITSEL   0:1/1  1:1/2    2:1/4   ...  7:1/128@
--             | | +-+-------- PRESCALER   0:1/1  1:1/256  2:1/65536
--             | +------------ FCINSEL     gJE^[͐ؑ  0: 1:gϊ
--             +-------------- SEQ         0:P   1: A
--  
--  
--    0x02   7 6 5 4 3 2 1 0
--           | | | | +-+-+-+-- SIGSEL     ͐ؑ 0:D0 1:D1 ... 14:D14 15:AiO
--           | +-+-+---------- FMCICSEL   FM g CIC iؑ  0:128 1:256 ... 5:4096
--           +---------------- TRGEDGE    gK[ó@0:オ@1:
--
--
--    0x03   7 6 5 4 3 2 1 0
--                   +-+-+-+-- FMSEQN     񂲂ƂɋL^邩 0:1@1:2@2:4  ... 15:32768񂲂
--                                        PHASEOV & PHASE
--
--
-- READ
--    0x00   7 6 5 4 3 2 1 0
--                     | +-+-- STATE  0:I 1:Jn 2:JnJE^[l擾 or A蒆
--                     +------ FSIGN  g̕ 0: 1:
--  
--    0x01   SEQCNT   (  7 downto  0 )
--    0x02   MESCNT   (  7 downto  0 )
--    0x03   CNT_STOP (  7 downto  0 )
--    0x04   CNT_STOP ( 15 downto  8 )
--    0x05   CNT_STOP ( 23 downto 16 )
--    0x06   CNT_STOP ( 31 downto 24 )
--    0x07   CNT_START(  7 downto  0 )
--    0x08   CNT_START( 15 downto  8 )
--    0x09   CNT_START( 23 downto 16 )
--    0x0A   CNT_START( 31 downto 24 )
--  
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity freqdet is
  port (
    RESET   : in  std_logic;                      -- 
    CLK     : in  std_logic;
    
    MCE     : in  std_logic;                      -- Cl[u
    MWE     : in  std_logic;                      -- 
    MADR    : in  std_logic_vector(15 downto 0);  -- AhX
    MWDATA  : in  std_logic_vector( 7 downto 0);  -- ރf[^
    MRDATA  : out std_logic_vector( 7 downto 0);  -- ǂݏof[^
    
    CNT32   : in std_logic_vector(31 downto 0);   -- t[JE^[l
    
    DSIGIN  : in std_logic_vector(7 downto 0);    -- MfW^
    ASIGIN  : in std_logic_vector(15 downto 0);   -- AiO( ADC1610 o )
    
    I_IN    : in std_logic_vector(17 downto 0);   -- gϊ CIC ʂM
    Q_IN    : in std_logic_vector(17 downto 0);
    ND      : in  std_logic;                      -- I_IN, Q_IN L
    
    DET_OUT : out std_logic_vector (15 downto 0);   -- FMo
    MEMWDATA : out std_logic_vector (31 downto 0);  -- [ݗpf[^o
    MEMWE    : out std_logic;                       -- lݗL
    TRG      : out std_logic                        -- gK[
    
  );
end freqdet;


architecture RTL of freqdet is
--  signal ND1    : std_logic;                      -- 156kHz
  signal FMOD   : std_logic;                      -- 
  
  signal I_D   : std_logic;
  
  signal D       : std_logic_vector (15 downto 0);
  signal PREVDETSIGN : std_logic;                     --PO FMDET ̕
  signal PHASE   : std_logic_vector (15 downto 0);
  signal PHASEOV : std_logic_vector (15 downto 0);    -- PHASE ̃I[o[t[
  signal FMSEQCNT: std_logic_vector (16 downto 0);    -- 񂲂ƂɋL^邩̃JE^[
  
  signal SIG        : std_logic;                      -- M
  signal FC_SIG     : std_logic;                      -- gJE^[M
  signal ASIG       : std_logic;                      -- AiOM͂̔g``
  
  signal STATE      : std_logic_vector( 1 downto 0);  -- Xe[g
  signal FSIGN      : std_logic;                      -- g̕ 0: 1:
  signal SEQCNT     : std_logic_vector( 7 downto 0);  -- 
  signal MESCNT     : std_logic_vector( 7 downto 0);  -- rbgJE^[
  signal CNT_START  : std_logic_vector(31 downto 0);  -- JnJE^[l
  signal CNT_STOP   : std_logic_vector(31 downto 0);  -- IJE^[l
  signal FCOD       : std_logic;                      -- 
  
  signal START      : std_logic;                      -- Jn
  signal STOP       : std_logic;                      -- I
  
  signal MESBITSEL  : std_logic_vector( 2 downto 0);  -- rbgI@0:1/1  1:1/2  2:1/4 .... 7:1/128
  signal PRESCALER  : std_logic_vector( 1 downto 0);  -- vXP[I@0:1/1  1:1/256  2:1/256/256
  signal FCINSEL    : std_logic;                      -- gJE^[͐ؑ
  signal SEQ        : std_logic;                      -- 0:P   1: A
  
  signal SIGSEL     : std_logic_vector(3 downto 0);   -- ͐ؑ
  signal FMCICSEL   : std_logic_vector(2 downto 0);   -- FM g CIC iؑ  0:128 1:256 2:512 3:1024 4:2048 5:4096
  signal TRGEDGE    : std_logic;                      -- gK[ó@0:オ@1:
  signal FMSEQN     : std_logic_vector(3 downto 0);   -- 񂲂ƂɋL^邩 0:1@1:2@2:4  ... 15:32768񂲂
  
  signal PREVPHASESIGN : std_logic;                   -- PO PHASE ̕
  
  
  component fm_det_cordic   -- FM 
  port (
    RESET   : in  std_logic;                       -- 
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- New Data
    I_IN    : in  std_logic_vector( 15 downto 0 ); -- I M
    Q_IN    : in  std_logic_vector( 15 downto 0 ); -- Q M
    DET_OUT : out std_logic_vector( 15 downto 0 ); -- FMo̓f[^(ʑ)
    PHASE_OUT: out std_logic_vector( 15 downto 0 ); -- ʑo
    OD      : out std_logic                        -- o̓f[^L
  );
  end component;
  
  
  component freqcounter
    port (
      RESET     : in  std_logic;
      CLK       : in  std_logic; 
      
      CNT32     : in std_logic_vector(31 downto 0);  -- JE^[l
      
      SIGIN     : in  std_logic;                     -- M
      START     : in  std_logic;                     -- Jn
      STOP      : in  std_logic;                     -- I
      SEQ       : in  std_logic;                     -- 0:P   1: A
      MESBITSEL : in  std_logic_vector( 2 downto 0); -- 0:1/1  1:1/2  2:1/4 .... 7:1/128
      PRESCALER : in  std_logic_vector( 1 downto 0); -- 0:1/1  1:1/256  2:1/65536
      
      STATE     : out std_logic_vector( 1 downto 0);
      SEQCNT    : out std_logic_vector( 7 downto 0);
      MESCNT    : out std_logic_vector( 7 downto 0);
      CNT_START : out std_logic_vector(31 downto 0);
      CNT_STOP  : out std_logic_vector(31 downto 0);
      OD        : out std_logic                     -- VlL
    );
  end component;
  
  
begin
  
  U2: fm_det_cordic
  port map (
    RESET     => RESET,         -- 
    CLK       => CLK,
    I_IN      => I_IN(17 downto 2),
    Q_IN      => Q_IN(17 downto 2),
    ND        => ND,        
    DET_OUT   => D,
    PHASE_OUT => PHASE,
    OD        => FMOD
  );
  
  
  U3 : freqcounter
  port map (
    RESET     => RESET,
    CLK       => CLK,
    
    CNT32     => CNT32,                 -- JE^[l
    
    SIGIN     => FC_SIG,                -- M
    START     => START,                 -- Jn
    STOP      => STOP,                  -- I
    SEQ       => SEQ,                   -- 0:P   1: A
    MESBITSEL => MESBITSEL,             -- 0:1/1  1:1/2  2:1/4 .... 7:1/128
    PRESCALER => PRESCALER,             -- 0:1/1  1:1/256  2:1/65536
    
    STATE     => STATE,                 -- : out std_logic_vector( 1 downto 0);
    SEQCNT    => SEQCNT,                -- : out std_logic_vector( 7 downto 0);
    MESCNT    => MESCNT,                -- : out std_logic_vector( 7 downto 0);
    CNT_START => CNT_START,             -- : out std_logic_vector(31 downto 0);
    CNT_STOP  => CNT_STOP,              -- : out std_logic_vector(31 downto 0)
    OD        => FCOD                   -- VlL
  );
  
  
  DET_OUT <= D;
  
  
  SIG <=  DSIGIN(0)  when( SIGSEL=X"0") else
          DSIGIN(1)  when( SIGSEL=X"1") else
          DSIGIN(2)  when( SIGSEL=X"2") else
          DSIGIN(3)  when( SIGSEL=X"3") else
          DSIGIN(4)  when( SIGSEL=X"4") else
          DSIGIN(5)  when( SIGSEL=X"5") else
          DSIGIN(6)  when( SIGSEL=X"6") else
          DSIGIN(7)  when( SIGSEL=X"7") else
          ASIG;
  
  FC_SIG <= SIG when( FCINSEL ='0' ) else
            I_IN(17);  -- <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<@Ƃ肠 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  
  MEMWDATA <= PHASEOV & PHASE;
  
  
  ------------------------------------------------------------------
  --    ݒAʓǂݏo
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( MWE='1' and MCE='1') then
        case MADR( 1 downto 0 ) is
          when( "00" ) => 
            if( MWDATA(0) = '1' ) then            -- 1 ƎgJE^Jn@0 ƎgJE^Ii~j
              START <= '1';
            else
              STOP  <= '1';
            end if;
          when( "01" ) => 
            MESBITSEL <= MWDATA(2 downto 0);      -- 0:1/1  1:1/2  2:1/4 .... 7:1/128
            PRESCALER <= MWDATA(4 downto 3);      -- 0:1/1  1:1/256  2:1/65536
            FCINSEL   <= MWDATA(5);               -- gJE^[͐ؑ  0: 1:gϊ
            SEQ       <= MWDATA(6);               -- 0:P   1: A
          when( "10" ) => 
            SIGSEL   <= MWDATA(3 downto 0);       -- ͐ؑ
            FMCICSEL <= MWDATA(6 downto 4);       -- FM g CIC iؑ  0:32 1:64 2:128 ...  7:4096
            TRGEDGE  <= MWDATA(7);                -- gK[ó@0:オ@1:
          when others => 
            FMSEQN   <= MWDATA(3 downto 0);       -- 񂲂ƂɋL^邩 0:1@1:2@2:4  ... 15:32768񂲂
        end case;
      else
        START <= '0';
        STOP  <= '0';
      end if;
    end if;
  end process;
  
  
  MRDATA <=  "00000000"                 when( MCE='0' ) else
             "00000" & FSIGN & STATE    when( MADR(3 downto 0) =X"0" ) else  -- FSIGN  g̕ 0: 1:
             SEQCNT                     when( MADR(3 downto 0) =X"1" ) else
             MESCNT                     when( MADR(3 downto 0) =X"2" ) else
             CNT_STOP(  7 downto  0 )   when( MADR(3 downto 0) =X"3" ) else
             CNT_STOP( 15 downto  8 )   when( MADR(3 downto 0) =X"4" ) else
             CNT_STOP( 23 downto 16 )   when( MADR(3 downto 0) =X"5" ) else
             CNT_STOP( 31 downto 24 )   when( MADR(3 downto 0) =X"6" ) else
             CNT_START(  7 downto  0 )  when( MADR(3 downto 0) =X"7" ) else
             CNT_START( 15 downto  8 )  when( MADR(3 downto 0) =X"8" ) else
             CNT_START( 23 downto 16 )  when( MADR(3 downto 0) =X"9" ) else
             CNT_START( 31 downto 24 ) ;
  
  
  ------------------------------------------------------------------
  --    g̕
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( ND = '1' ) then
        I_D <= I_IN(17);
        if( I_D='0' and I_IN(17)='1' ) then -- rising edge
          FSIGN <= Q_IN(17);
        end if;
      end if;
    end if;
  end process;
  
  
  ------------------------------------------------------------------
  --    ʑ̃I[o[t[oAMEMWE o
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if( RESET = '1' ) then
      PHASEOV <= (others => '0');
      FMSEQCNT <= "00000000000000001";
    elsif( rising_edge(CLK) ) then
      if( FMOD = '1' ) then
        if   ( PREVPHASESIGN='0' and PHASE(15)='1' and D(15)='0' ) then PHASEOV <= PHASEOV + 1;
        elsif( PREVPHASESIGN='1' and PHASE(15)='0' and D(15)='1' ) then PHASEOV <= PHASEOV - 1; end if;
        PREVPHASESIGN <= PHASE(15);
        
        if( FMSEQCNT(CONV_INTEGER(FMSEQN)) = '1' ) then
          FMSEQCNT <= "00000000000000001";
          MEMWE  <= '1';
        else
          FMSEQCNT <= FMSEQCNT + 1;
        end if;
        
      else
        MEMWE <= '0';
      end if;
    end if;
  end process;
  
  
  ------------------------------------------------------------------
  --    gK[o
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if( RESET = '1' ) then
    
    elsif( rising_edge(CLK) ) then
      if( FMOD = '1' ) then
        PREVDETSIGN <= D(15);
        if( TRGEDGE='0' and PREVDETSIGN='0' and D(15)='1' ) then TRG <= '1'; end if; -- オ
        if( TRGEDGE='1' and PREVDETSIGN='1' and D(15)='0' ) then TRG <= '1'; end if;
      else
        TRG <= '0';
      end if;
    end if;
  end process;
  
  
  ------------------------------------------------------------------
  --    AiOM͂̔g``@@XbV -48dB
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if( RESET = '1' ) then
      ASIG <= '0';
    elsif( rising_edge(CLK) ) then
      if( ASIG='0' and ASIGIN(15)='0' and ASIGIN(14 downto 7) /= "00000000" ) then ASIG <= '1'; end if; -- XbV𒴂
      if( ASIG='1' and ASIGIN(15)='1' and ASIGIN(14 downto 7) /= "11111111" ) then ASIG <= '0'; end if; -- XbV𒴂
    end if;
  end process;
  
  
end RTL;

