----------------------------------------------------------------------------------
--  
--        iir.vhd        IIR tB^[ ( 4ch x 16BiQuad, 2048 clk )
--  
--        (c)2010/01/11  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO OjisanKoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓI
--  p͂߂B
--
--
--20100114 RESET@V~[V܂łȂB@Ԃ memwe  U ɂȂĂ܂
-- Number of Slices:                      228  out of   2448     9%  
-- Number of Slice Flip Flops:            308  out of   4896     6%  
-- Number of 4 input LUTs:                174  out of   4896     3%  
-- Number of IOs:                         181
-- Number of bonded IOBs:                 176  out of     66   266% (*) 
-- Number of BRAMs:                         1  out of     12     8%  
-- Number of MULT18X18SIOs:                 1  out of     12     8%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 8.630ns (Maximum Frequency: 115.881MHz)
--   Minimum input arrival time before clock: 3.864ns
--   Maximum output required time after clock: 4.935ns
--   Maximum combinational path delay: 7.247ns
--
--
--20100114 񓯊RESET
-- Number of Slices:                      248  out of   2448    10%  
-- Number of Slice Flip Flops:            308  out of   4896     6%  
-- Number of 4 input LUTs:                214  out of   4896     4%  
-- Number of IOs:                         181
-- Number of bonded IOBs:                 177  out of     66   268% (*) 
-- Number of BRAMs:                         1  out of     12     8%  
-- Number of MULT18X18SIOs:                 1  out of     12     8%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 9.668ns (Maximum Frequency: 103.439MHz)
--   Minimum input arrival time before clock: 6.640ns
--   Maximum output required time after clock: 4.935ns
--   Maximum combinational path delay: 7.247ns
--


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

------------------------------------------------------------------------------
entity iir is 
  port (
    RESET   : in  STD_LOGIC;                        -- 
    CLK     : in  STD_LOGIC;                        -- 100MHz
    NDIN    : in  STD_LOGIC;                        -- ͓M 39KHz
    DIN_0   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[́@O
    DIN_1   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[́@P
    DIN_2   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[́@Q
    DIN_3   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[́@R
    DOUT_0  : out STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[ó@O
    DOUT_1  : out STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[ó@P
    DOUT_2  : out STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[ó@Q
    DOUT_3  : out STD_LOGIC_VECTOR( 17 downto 0 );  -- tB^[ó@R
    
    MEME    : in  STD_LOGIC;                        -- 
    MWE     : in  STD_LOGIC;                        -- 
    MADR    : in  STD_LOGIC_VECTOR ( 15 downto 0);  -- W[AhX
    MWDATA  : in  STD_LOGIC_VECTOR (  7 downto 0);  -- W[f[^
    MRDATA  : out STD_LOGIC_VECTOR (  7 downto 0)   -- W[f[^o
  );
end iir;


------------------------------------------------------------------------------
architecture RTL of iir is
  
  signal MEMADR     : STD_LOGIC_VECTOR( 9 downto 0 )  ; -- [AhX A
  signal DOUTA      : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- [f[^o A
  signal MEMWE      : STD_LOGIC_VECTOR( 0 downto 0 )  ; -- [ A
  signal DIN_00     : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- f[^0 ̃obt@
  signal DIN_11     : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- f[^1 ̃obt@
  signal DIN_22     : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- f[^2 ̃obt@
  signal DIN_33     : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- f[^3 ̃obt@
  signal DOUT_00    : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- f[^o0 ̃obt@
  signal DOUT_11    : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- f[^o1 ̃obt@
  signal DOUT_22    : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- f[^o2 ̃obt@
  signal DOUT_33    : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- f[^o3 ̃obt@
  signal DINA       : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- [f[^ B
  signal DINB       : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- [f[^ B
  signal DINB1      : STD_LOGIC_VECTOR( 15 downto 0 ) ; -- [f[^ B
  signal DOUTB      : STD_LOGIC_VECTOR( 17 downto 0 ) ; -- [f[^o B
  signal WEB        : STD_LOGIC_VECTOR( 0 downto 0 )  ; -- [ B
  
  signal CNT        : STD_LOGIC_VECTOR( 10 downto 0 ) ; -- S̃JE^[    2048
  
  signal MAC        : STD_LOGIC_VECTOR( 35 downto 0 ) ; -- ϘaZAL[^[
  
  signal MULOUT     : STD_LOGIC_VECTOR( 35 downto 0 ) ; -- |Zo
  
  subtype B3 is STD_LOGIC_VECTOR (2 downto 0);
  type B3TBL is array (0 to 7) of B3;
  constant ADR0 :B3TBL := ( "011", "101", "100", "010", "001", "000", "111", "111" );
  constant ADR1 :B3TBL := ( "000", "110", "101", "011", "010", "001", "100", "111" );
  
  component RAM1024x18_IIR
    port (
    clka  : IN std_logic;
    dina  : IN std_logic_VECTOR(17 downto 0);
    addra : IN std_logic_VECTOR(9 downto 0);
    wea   : IN std_logic_VECTOR(0 downto 0);
    douta : OUT std_logic_VECTOR(17 downto 0);
    clkb  : IN std_logic;
    dinb  : IN std_logic_VECTOR(17 downto 0);
    addrb : IN std_logic_VECTOR(9 downto 0);
    web   : IN std_logic_VECTOR(0 downto 0);
    doutb : OUT std_logic_VECTOR(17 downto 0));
  end component;
  
  
begin
  
  U0 : RAM1024x18_IIR
  port map (
    clka  => CLK,
    dina  => DINA,
    addra => MEMADR,
    wea   => MEMWE,
    douta => DOUTA,
    
    clkb  => CLK,
    dinb  => DINB,
    addrb => MADR(11 downto 2),
    web   => WEB,
    doutb => DOUTB
  );
  
  
  U1 : MULT18X18
  port map (
    P   => MULOUT,        -- 36-bit multiplier output
    A   => DOUTA,         -- W
    B   => DINA           -- f[^
  );
  
  
  ------------------------------------------------------------------
  --    hhqtB^[Z
  ------------------------------------------------------------------
  process( RESET, CLK ) begin

--    -- if SIMULATION
--    if( RESET = '1' ) then  -- V~[Vɂ͔񓯊RESETKv
--      CNT   <= (others=>'0');
--      MAC   <= (others=>'0');
--      MEMWE <= "0";
--    else
--      if( rising_edge(CLK) ) then
    
    if( rising_edge(CLK) ) then -- ۂ̃Cvɂ͂iRESETjg
      if( RESET = '1' ) then
        CNT   <= (others=>'0');
        MAC   <= (others=>'0');
        MEMWE <= "0";
      else
        
        if( NDIN = '1' ) then                     --
          CNT <= (others => '0');                 -- ͐M
        else
          CNT <= CNT+1;
        end if;
        
        if( CNT="00000000000" ) then              -- SchɃf[^b`ɎgpASchɏo͂
          DIN_00 <= DIN_0(17)&DIN_0(17)&DIN_0(16 downto 1); -- ZŃI[o[t[Ȃ悤ɂP^Qɂ
          DIN_11 <= DIN_1(17)&DIN_1(17)&DIN_1(16 downto 1);
          DIN_22 <= DIN_2(17)&DIN_2(17)&DIN_2(16 downto 1);
          DIN_33 <= DIN_3(17)&DIN_3(17)&DIN_3(16 downto 1);
          DOUT_0 <= DOUT_00(17)&DOUT_00(15 downto 0)&'0';   -- ͂łP^QĂ̂łQ{
          DOUT_1 <= DOUT_11(17)&DOUT_11(15 downto 0)&'0';
          DOUT_2 <= DOUT_22(17)&DOUT_22(15 downto 0)&'0';
          DOUT_3 <= DOUT_33(17)&DOUT_33(15 downto 0)&'0';
        end if;
        
        if( CNT(1 downto 0)="10" ) then
          if( CNT(8 downto 2)="0000000" ) then
            if( CNT(10 downto 9)="00" ) then
              DINA <= DIN_00;
            elsif( CNT(10 downto 9)="01" ) then
              DINA <= DIN_11;
            elsif( CNT(10 downto 9)="10" ) then
              DINA <= DIN_22;
            else
              DINA <= DIN_33;
            end if;
          elsif( CNT(4 downto 2)="000" or CNT(4 downto 2)="110" ) then
            DINA <= MAC( 32 downto 15 )+MAC(14);          -- WXP[OSȂ̂łQrbgE
          elsif( CNT(4 downto 2)="111" ) then 
            if( MAC(32)='0' ) then                -- ̂Ƃ
              if( MAC( 31 downto 15 ) > DOUTA( 16 downto 0 ) ) then -- őlz[h ADR=111 ɏ
                DINA <= MAC( 32 downto 15 );
              else
                DINA <= DOUTA;
              end if;
            else
              DINA <= DOUTA;
            end if;
          else
            DINA <= DOUTA;
          end if;
          MEMWE <= "1";
        else
          MEMWE <= "0";
        end if;
        
        if( CNT(8 downto 0)="111111111" ) then
          if( CNT(10 downto 9)="00" ) then
            DOUT_00 <= (MAC(35) & MAC(24 downto 8))+MAC(7);  -- o͂ 256{Ăi gain ݒ j
          elsif( CNT(10 downto 9)="01" ) then
            DOUT_11 <= (MAC(35) & MAC(24 downto 8))+MAC(7);
          elsif( CNT(10 downto 9)="10" ) then
            DOUT_22 <= (MAC(35) & MAC(24 downto 8))+MAC(7);
          else
            DOUT_33 <= (MAC(35) & MAC(24 downto 8))+MAC(7);
          end if;
        end if;
        
        if( CNT(1 downto 0) = "11" ) then         -- 
          if( CNT(4 downto 2) = "000" ) then      -- 
            MAC <= (others => '0');               -- MAC clear
          else
            MAC <= MAC + MULOUT;                  -- ϘaZ
          end if;
        end if;
        
        if( CNT(1 downto 0) = "00" ) then         -- 
          MEMADR(9) <= '1';
          MEMADR(8 downto 3) <= CNT(10 downto 5);
          MEMADR(2 downto 0) <= ADR0(CONV_INTEGER(CNT(4 downto 2))); 
        elsif( CNT(1 downto 0) = "01" ) then      -- 
          MEMADR(9) <= '0';
        elsif( CNT(1 downto 0) = "10" ) then      -- 
          MEMADR(9) <= '1'; 
          MEMADR(2 downto 0) <= ADR1(CONV_INTEGER(CNT(4 downto 2))); 
        end if;
        
      end if;
    end if;
  end process;
  
  
  ------------------------------------------------------------------
  --    [ǂݏ
  ------------------------------------------------------------------
  
  WEB     <= "1" when( MWE='1' and MEME='1' and MADR(1 downto 0)="10" ) else "0";
  
  MRDATA  <= "00000000"  when(MEME='0') else
             DOUTB( 7 downto 0 ) when( MADR(1 downto 0)="00" ) else
             DOUTB(15 downto 8 ) when( MADR(1 downto 0)="01" ) else
             "000000" & DOUTB(17 downto 16);
  
  DINB    <= MWDATA(1 downto 0) & DINB1;
  
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( MWE='1' and MEME='1'  ) then
        if( MADR( 1 downto 0 ) = "00" ) then
          DINB1( 7 downto 0 ) <= MWDATA;    -- 
        elsif( MADR( 1 downto 0 ) = "01" ) then
          DINB1(15 downto 8 ) <= MWDATA;    -- 
        end if;
      end if;
    end if;
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------

