----------------------------------------------------------------------------------
--  
--        shiftra18.vhd        ZpEVtg@16rbgf[^
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
--
--PAQASrbgVtĝ
--Selected Device : 3s200avq100-4 
--
-- Number of Slices:                       38  out of   1792     2%  
-- Number of 4 input LUTs:                 69  out of   3584     1%  
-- Number of IOs:                          40
-- Number of bonded IOBs:                  40  out of     68    58%  
--
--   Minimum period: No path found
--   Minimum input arrival time before clock: No path found
--   Maximum output required time after clock: No path found
--   Maximum combinational path delay: 11.659ns
--
--erbgƂɃZN^[
--Selected Device : 3s200avq100-4 
--
-- Number of Slices:                       48  out of   1792     2%  
-- Number of 4 input LUTs:                 91  out of   3584     2%  
-- Number of IOs:                          40
-- Number of bonded IOBs:                  40  out of     68    58%  
--
--   Minimum period: No path found
--   Minimum input arrival time before clock: No path found
--   Maximum output required time after clock: No path found
--   Maximum combinational path delay: 12.116ns
--
--
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity shiftra18 is 
  port (
    X   : in  std_logic_vector( 17 downto 0 ); -- 
    Y   : out std_logic_vector( 17 downto 0 ); -- o̓f[^
    N   : in  std_logic_vector( 3 downto 0 )   -- Vtg
  );
end shiftra18;


------------------------------------------------------------------------------
architecture RTL of shiftra18 is
  
  signal X1 : std_logic_vector( 17 downto 0 ); -- 1 bit Vtg
  signal X2 : std_logic_vector( 17 downto 0 ); -- 2 bit Vtg
  signal X4 : std_logic_vector( 17 downto 0 ); -- 4 bit Vtg
  
begin
  
  X1 <= X  when( N(0)='0' ) else
        X(17) & X(17 downto 1);
  
  X2 <= X1 when( N(1)='0' ) else
        X1(17) & X1(17) & X1(17 downto 2);
  
  X4 <= X2 when( N(2)='0' ) else
        X2(17) & X2(17) & X2(17) & X2(17) & X2(17 downto 4);
  
  Y  <= X4 when( N(3)='0' ) else
        X4(17) & X4(17) & X4(17) & X4(17) & X4(17) & X4(17) & X4(17) & X4(17) & X4(17 downto 8);
  
  
--  Y(17) <= X(17);
--  
--  Y(16) <= X(16) when( N="0000" ) else
--           X(17);
--  
--  Y(15) <= X(15) when( N="0000" ) else
--           X(16) when( N="0001" ) else
--           X(17);
--  
--  Y(14) <= X(14) when( N="0000" ) else
--           X(15) when( N="0001" ) else
--           X(16) when( N="0010" ) else
--           X(17);
--  
--  Y(13) <= X(13) when( N="0000" ) else
--           X(14) when( N="0001" ) else
--           X(15) when( N="0010" ) else
--           X(16) when( N="0011" ) else
--           X(17);
--  
--  Y(12) <= X(12) when( N="0000" ) else
--           X(13) when( N="0001" ) else
--           X(14) when( N="0010" ) else
--           X(15) when( N="0011" ) else
--           X(16) when( N="0100" ) else
--           X(17);
--  
--  Y(11) <= X(11) when( N="0000" ) else
--           X(12) when( N="0001" ) else
--           X(13) when( N="0010" ) else
--           X(14) when( N="0011" ) else
--           X(15) when( N="0100" ) else
--           X(16) when( N="0101" ) else
--           X(17);
--  
--  Y(10) <= X(10) when( N="0000" ) else
--           X(11) when( N="0001" ) else
--           X(12) when( N="0010" ) else
--           X(13) when( N="0011" ) else
--           X(14) when( N="0100" ) else
--           X(15) when( N="0101" ) else
--           X(16) when( N="0110" ) else
--           X(17);
--  
--  Y(9)  <= X( 9) when( N="0000" ) else
--           X(10) when( N="0001" ) else
--           X(11) when( N="0010" ) else
--           X(12) when( N="0011" ) else
--           X(13) when( N="0100" ) else
--           X(14) when( N="0101" ) else
--           X(15) when( N="0110" ) else
--           X(16) when( N="0111" ) else
--           X(17);
--  
--  Y(8)  <= X( 8) when( N="0000" ) else
--           X( 9) when( N="0001" ) else
--           X(10) when( N="0010" ) else
--           X(11) when( N="0011" ) else
--           X(12) when( N="0100" ) else
--           X(13) when( N="0101" ) else
--           X(14) when( N="0110" ) else
--           X(15) when( N="0111" ) else
--           X(16) when( N="1000" ) else
--           X(17);
--  
--  Y(7)  <= X( 7) when( N="0000" ) else
--           X( 8) when( N="0001" ) else
--           X( 9) when( N="0010" ) else
--           X(10) when( N="0011" ) else
--           X(11) when( N="0100" ) else
--           X(12) when( N="0101" ) else
--           X(13) when( N="0110" ) else
--           X(14) when( N="0111" ) else
--           X(15) when( N="1000" ) else
--           X(16) when( N="1001" ) else
--           X(17);
--  
--  Y(6)  <= X( 6) when( N="0000" ) else
--           X( 7) when( N="0001" ) else
--           X( 8) when( N="0010" ) else
--           X( 9) when( N="0011" ) else
--           X(10) when( N="0100" ) else
--           X(11) when( N="0101" ) else
--           X(12) when( N="0110" ) else
--           X(13) when( N="0111" ) else
--           X(14) when( N="1000" ) else
--           X(15) when( N="1001" ) else
--           X(16) when( N="1010" ) else
--           X(17);
--  
--  Y(5)  <= X( 5) when( N="0000" ) else
--           X( 6) when( N="0001" ) else
--           X( 7) when( N="0010" ) else
--           X( 8) when( N="0011" ) else
--           X( 9) when( N="0100" ) else
--           X(10) when( N="0101" ) else
--           X(11) when( N="0110" ) else
--           X(12) when( N="0111" ) else
--           X(13) when( N="1000" ) else
--           X(14) when( N="1001" ) else
--           X(15) when( N="1010" ) else
--           X(16) when( N="1011" ) else
--           X(17);
--  
--  Y(4)  <= X( 4) when( N="0000" ) else
--           X( 5) when( N="0001" ) else
--           X( 6) when( N="0010" ) else
--           X( 7) when( N="0011" ) else
--           X( 8) when( N="0100" ) else
--           X( 9) when( N="0101" ) else
--           X(10) when( N="0110" ) else
--           X(11) when( N="0111" ) else
--           X(12) when( N="1000" ) else
--           X(13) when( N="1001" ) else
--           X(14) when( N="1010" ) else
--           X(15) when( N="1011" ) else
--           X(16) when( N="1100" ) else
--           X(17);
--  
--  Y(3)  <= X( 3) when( N="0000" ) else
--           X( 4) when( N="0001" ) else
--           X( 5) when( N="0010" ) else
--           X( 6) when( N="0011" ) else
--           X( 7) when( N="0100" ) else
--           X( 8) when( N="0101" ) else
--           X( 9) when( N="0110" ) else
--           X(10) when( N="0111" ) else
--           X(11) when( N="1000" ) else
--           X(12) when( N="1001" ) else
--           X(13) when( N="1010" ) else
--           X(14) when( N="1011" ) else
--           X(15) when( N="1100" ) else
--           X(16) when( N="1101" ) else
--           X(17);
--  
--  Y(2)  <= X( 2) when( N="0000" ) else
--           X( 3) when( N="0001" ) else
--           X( 4) when( N="0010" ) else
--           X( 5) when( N="0011" ) else
--           X( 6) when( N="0100" ) else
--           X( 7) when( N="0101" ) else
--           X( 8) when( N="0110" ) else
--           X( 9) when( N="0111" ) else
--           X(10) when( N="1000" ) else
--           X(11) when( N="1001" ) else
--           X(12) when( N="1010" ) else
--           X(13) when( N="1011" ) else
--           X(14) when( N="1100" ) else
--           X(15) when( N="1101" ) else
--           X(16) when( N="1110" ) else
--           X(17);
--  
--  Y(1)  <= X( 1) when( N="0000" ) else
--           X( 2) when( N="0001" ) else
--           X( 3) when( N="0010" ) else
--           X( 4) when( N="0011" ) else
--           X( 5) when( N="0100" ) else
--           X( 6) when( N="0101" ) else
--           X( 7) when( N="0110" ) else
--           X( 8) when( N="0111" ) else
--           X( 9) when( N="1000" ) else
--           X(10) when( N="1001" ) else
--           X(11) when( N="1010" ) else
--           X(12) when( N="1011" ) else
--           X(13) when( N="1100" ) else
--           X(14) when( N="1101" ) else
--           X(15) when( N="1110" ) else
--           X(16);
--  
--  Y(0)  <= X( 0) when( N="0000" ) else
--           X( 1) when( N="0001" ) else
--           X( 2) when( N="0010" ) else
--           X( 3) when( N="0011" ) else
--           X( 4) when( N="0100" ) else
--           X( 5) when( N="0101" ) else
--           X( 6) when( N="0110" ) else
--           X( 7) when( N="0111" ) else
--           X( 8) when( N="1000" ) else
--           X( 9) when( N="1001" ) else
--           X(10) when( N="1010" ) else
--           X(11) when( N="1011" ) else
--           X(12) when( N="1100" ) else
--           X(13) when( N="1101" ) else
--           X(14) when( N="1110" ) else
--           X(15);

end RTL;
----------------------------- end of architecture ----------------------------

