----------------------------------------------------------------------------------
--  
--        ssb.vhd        rra
--  
--        (c)2009/12/05  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO OjisanKoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓI
--  p͂߂B
--
--20100204
-- Number of Slices:                      131  out of   2448     5%  
-- Number of Slice Flip Flops:            187  out of   4896     3%  
-- Number of 4 input LUTs:                162  out of   4896     3%  
-- Number of IOs:                          56
-- Number of bonded IOBs:                  56  out of     66    84%  
-- Number of BRAMs:                         1  out of     12     8%  
-- Number of MULT18X18SIOs:                 1  out of     12     8%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 9.593ns (Maximum Frequency: 104.242MHz)
--   Minimum input arrival time before clock: 4.733ns
--   Maximum output required time after clock: 4.040ns
--   Maximum combinational path delay: No path found
--


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

------------------------------------------------------------------------------
entity ssb is 
  port (
    RESET   : in  std_logic;                       -- 
    CLK     : in  std_logic;                       -- 100MHz
    ND      : in  std_logic;                       -- New Data
    I_IN    : in  std_logic_vector( 17 downto 0 ); -- I M
    Q_IN    : in  std_logic_vector( 17 downto 0 ); -- Q M
    SSB_OUT : out std_logic_vector( 15 downto 0 ); -- SSBo̓f[^
    SSBSEL  : in  std_logic                        -- USBI  0:LSB 1:USB
  );
end ssb;


------------------------------------------------------------------------------
architecture RTL of ssb is
  
  signal DOUT_I   : STD_LOGIC_VECTOR( 15 downto 0 );   -- tB^[ó@O
  signal DOUT_Q   : STD_LOGIC_VECTOR( 15 downto 0 );   -- tB^[ó@P
  signal NDOUT    : STD_LOGIC;                         -- Mo̓^C~O
  
  component fir255_hilbert   -- FIR HILBERT ( 255 tap, 1024 clk )
  port (
    RESET   : in  STD_LOGIC;                        -- 
    CLK     : in  STD_LOGIC;                        -- 100MHz
    NDIN    : in  STD_LOGIC;                        -- ͓M  156.25kHz
    DIN_I   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- f[^́@O
    DIN_Q   : in  STD_LOGIC_VECTOR( 17 downto 0 );  -- f[^́@P
    NDOUT   : out STD_LOGIC;                        -- o͓M
    DOUT_I  : out STD_LOGIC_VECTOR( 15 downto 0 );  -- tB^[ó@O
    DOUT_Q  : out STD_LOGIC_VECTOR( 15 downto 0 );  -- tB^[ó@P
    
    MEME    : in  STD_LOGIC;                        -- 
    MWE     : in  STD_LOGIC;                        -- 
    MADR    : in  STD_LOGIC_VECTOR ( 15 downto 0);  -- W[AhX
    DATAIN  : in  STD_LOGIC_VECTOR (  7 downto 0);  -- W[f[^
    DATAOUT : out STD_LOGIC_VECTOR (  7 downto 0)   -- W[f[^o
  );
  end component;
  
  
  begin
    
    F0: fir255_hilbert   -- FIR HILBERT ( 255 tap, 1024 clk )
    port map (
      RESET   => RESET,
      CLK     => CLK,               -- 100MHz
      NDIN    => ND,                  -- 
      DIN_I   => I_IN,              -- f[^
      DIN_Q   => Q_IN,              -- f[^
      NDOUT   => NDOUT,                  -- 
      DOUT_I  => DOUT_I,            -- tB^[
      DOUT_Q  => DOUT_Q,            -- tB^[
      MEME    => '0',               -- 
      MWE     => '0',               -- 
      MADR    => "0000000000000000",-- W[AhX
      DATAIN  => "00000000",        -- W[f[^
      DATAOUT => open               -- W[f[^o
    );
    
    
    ------------------------------------------------------------------
    --    rra
    ------------------------------------------------------------------
    process( CLK ) begin
      if( rising_edge(CLK) ) then
        if( NDOUT = '1' ) then
          if( SSBSEL = '0' ) then
            SSB_OUT <= DOUT_I - DOUT_Q; -- LSB
          else
            SSB_OUT <= DOUT_I + DOUT_Q; -- USB
          end if;
        end if;
      end if;
    end process;
    
    
  end RTL;
----------------------------- end of architecture ----------------------------

